package WebFlow;
import WebFlow.event.*;
import WebFlow.*;

import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import org.omg.CORBA.*;
import java.net.*;
import WebFlow.xml.*;

import org.w3c.dom.*;
import java.sql.*;


//Read configuration file which looks like this:
//Module/Event Name -----  IDLfileName ----- Implementation Class
//Read this file and store it into "configTable"

public class configReaderImpl extends _configReaderImplBase
{
    private Hashtable configTable;
    //The table for idl files of all modules and events interface idls
    private Vector idlFiles;
    private static org.omg.CORBA.ORB orb_;
    Hashtable WFServers;
    public org.omg.CORBA.Object server_;
    public String localFile, masterURL, ServerName,ServerID;
    public boolean  non_existent=true ;
    public String parentName;
    public boolean isItMaster;
    public String masterServerIOR;
    public String xmlFileName_,IRstr,idlFilesDir,installerServlet;
    public Hashtable moduleList ;
    public Document rootDocument;
    public String installerURL;
    public String entityFlag;
    static Connection jdbc_connection; //JDBC connection
    public org.omg.CORBA.Object myProxy;

    public class interfaceAndImpl
    {
	public  String idlFileName_,implClassName_;
	public  String flag_;
    
	public interfaceAndImpl(String flag,String idlFileName,
			   String implClassName)
			
	{
	    flag_          = flag;
	    idlFileName_   = idlFileName;
	    implClassName_ = implClassName;
	}
    } //public class interfaceAndImpl

  public void setMyProxy(org.omg.CORBA.Object proxy){
    myProxy = proxy;
  }
  public org.omg.CORBA.Object getMyProxy(){
    return myProxy;
  }

    public String[] getModuleList()
    {
	Vector vmodules = new Vector();
	for(Enumeration list=configTable.elements();list.hasMoreElements();){
	    interfaceAndImpl val = (interfaceAndImpl)list.nextElement();
	    if (val.flag_.equals("Module"))
		vmodules.addElement(val);
	}
	String[]  modules = new String[vmodules.size()];
	vmodules.copyInto(modules);
	return modules;
	
    }

    public configReaderImpl(org.omg.CORBA.Object server,ORB orb, 
			    String xmlFileName,String installerURL )
    {
      this.installerURL = installerURL; 
      server_ = server;
      orb_ = orb;
      xmlFileName_ = xmlFileName;
      //later uncomment
      getIRString();

      Document document=null;
      try{
	DOMParser parser = new DOMParser();
	document = parser.parse(xmlFileName);
      }catch (Exception e) {
	e.printStackTrace(System.err);
	return;
      }
      rootDocument = document;
      //get preorder traversal of all onfigFile ELEMENTs
      NodeList elements = document.getElementsByTagName("configFile");
      for(int k=0;k<elements.getLength();k++)
	installConfigFiles(elements.item(k), true);

      //connect to database
      connectToDataBase("akarsu", "akarsu");
    }

     public configReaderImpl(ORB orb)
     {
       orb_ = orb;

     }

     public configReaderImpl(ORB orb,Document rootDocument )
     {
       orb_ = orb;
       this.rootDocument = rootDocument;
       //get preorder traversal of all onfigFile ELEMENTs
       NodeList elements = rootDocument.getElementsByTagName("configFile");
       for(int k=0;k<elements.getLength();k++)
	 installConfigFiles(elements.item(k), false);

       //connect to database
       connectToDataBase("akarsu", "akarsu");
    }
 
    public static Connection connectToDataBase(String user, 
						    String passwd) 
    { 
      jdbc_connection = null;
      String jdbc_url = "jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe";
      try {
        Class.forName("oracle.jdbc.driver.OracleDriver");
        jdbc_connection = DriverManager.getConnection(jdbc_url, user, passwd);
        System.out.println("Connection Open");
      }
      catch (Exception e) { 
	System.err.println("Error connection: " + e); 
	return null;
      }   
      return jdbc_connection;
    }

    public Document getDocument()
    {
      return rootDocument;
    }

    public void   installConfigFiles(Node configElement, boolean isFeedIDL)
    {
      //create table to keep available WebFlow Servers
      WFServers  = new Hashtable();
      configTable = new Hashtable();
      idlFiles    = new Vector();

      //get componentID and servlet_href attributes
      //component ID like this:a/b/c/ServerName
      Node pn = configElement;
      String tag;
      do{
	pn = pn.getParentNode();
	tag = pn.getNodeName();
      }while(!tag.equals("WebFlowContext"));
      Element wfc = (Element)pn;
      System.out.println("installConfigFiles:wfc:"+wfc);

      ServerID   = wfc.getAttribute("componentID");
      int index  = ServerID.lastIndexOf("/");
      ServerName = ServerID.substring(index+1);
      if (index <0)
	index = ServerID.length();

      //parentName = ServerID.substring(0,index);

      installerServlet =  wfc.getAttribute("servlet_href");
      System.out.println("installerServlet :"+installerServlet);

      entityFlag = wfc.getAttribute("entityFlag");
      System.out.println("entityFlag :"+entityFlag);

      System.out.println("Servername:"+ServerName+" serverid:"+ServerID);
      //if servername and serverID is equal, 
      //the context holding this configFile is behaves as a master

      //get first child of configFile element:it is master or slave
      Node status_node = configElement.getFirstChild().getNextSibling();
      Element status = (Element)status_node;
   
      idlFilesDir = status.getAttribute("idlFilesDir");
      System.out.println("idlFilesDir:"+idlFilesDir);
      
      String tagname = status.getTagName();
      if (tagname.equals("master")){
	localFile = status.getAttribute("localFile");
	System.out.println("I am master:localFile:"+localFile);
	//if there is one server running, then return
	//Uncommment later
	if (!isTheServerRunnning())
	  return;
	isItMaster = true;
      }
      else if (tagname.equals("slave")){
	System.out.println("I am slave..");
	//CHANGE:IMPORTANT
	parentName = status.getAttribute("parent");
	masterURL = status.getAttribute("masterURL");
	isItMaster = false;
	//Uncommment later
	getIORFromURL(masterURL);
      }
      //feed BC.idl first
      feedOneIDL("BC.idl", "");

      irfeedIdlFiles((Element)configElement, isFeedIDL);
    }  

    public Hashtable getModuleElements()
    {
      return moduleList;
    }

    public void irfeedIdlFiles(Element configElement, boolean isFeedIDL )
  {
      NodeList modules = configElement.getElementsByTagName("UserModule");
      NodeList impls= configElement.getElementsByTagName("implementation");

      if ((modules.getLength() == 0) || (impls.getLength() == 0))
	return;

      System.out.println("modulesLen:"+modules.getLength()+
			 "-implsLen:"+impls.getLength());

      Element  implnode = (Element)impls.item(0);
      NodeList moduleImpls   = implnode.getElementsByTagName("moduleImpl");
      moduleList = new Hashtable();

      for(int k=0;k<modules.getLength();k++){
	Element next = (Element)modules.item(k);
	String nextModuleName = next.getAttribute("componentID");
	moduleList.put(next.getAttribute("componentID"), next);
      }

      for(int k=0;k<moduleImpls.getLength();k++){
	Element nextImpl = (Element)moduleImpls.item(k);
	String moduleName = nextImpl.getAttribute("componentRef");
	String implClassName = nextImpl.getAttribute("implClass");
	String componentRef = moduleName;

	//check we declare same module with different alias name
	String aliasAtt =  nextImpl.getAttribute("aliasRef");
	System.out.println("Alias Attribute :"+aliasAtt+":"+aliasAtt.length());
	if (aliasAtt.length() > 0)
	  moduleName = nextImpl.getAttribute("aliasRef");
	//////

	Element nextModule = (Element)moduleList.get(moduleName);
	String idlFileName   = nextModule.getAttribute("idlFile");
	System.out.println("CONFIG="+moduleName+"="+idlFileName+"="
			     +implClassName);
	interfaceAndImpl iai = new interfaceAndImpl("Module",idlFileName,
						    implClassName);
	configTable.put(componentRef,iai);

	if (isFeedIDL)
	  feedOneIDL(idlFileName, " -D_WEBFLOW_ ");
	if (aliasAtt.length() > 0)
	  moduleList.put(componentRef, nextModule);
      }

  }

  public void feedOneIDL(String idlFileName, String flag)
  {
	 
    //Feed idl interface of this module
    if (idlFiles.indexOf(idlFileName) >= 0)
      return;
    String command = "irfeed -ORBrepository "+IRstr+" "+flag+
      " -I"+idlFilesDir+" "+idlFilesDir+"/"+idlFileName;
       
    System.out.println("Feeding idl:"+command); 		
    try{
      System.out.println("configReader :irfeeding the file:"+idlFileName);
      Process p = Runtime.getRuntime().exec(command);
      p.waitFor();
    }catch (Exception ex){
      System.out.println("Error in feeding IDL file :"+idlFileName+ " : "+ex);
    }
    idlFiles.addElement(idlFileName);
    
  }

  public void saveObjectInDataBase(String OID,String parentID,
				   String objectIOR, String proxyIOR,
				   boolean isOuter, String isModule)
  {
    System.out.println("saveObjectInDataBase:jdbc:"+jdbc_connection);
    String installerURL = null;
    if (isOuter)
      installerURL = this.installerURL;

    String stStr=null;
    try{
      java.sql.Statement stmt = jdbc_connection.createStatement();
      stStr = "insert into objects_table values(";
      stStr += "\'"+OID+"\', ";
      stStr += "\'"+parentID+"\', ";
      stStr += "\'"+objectIOR+"\',";
      stStr += "\'"+proxyIOR+"\',";
      stStr += "\'"+installerURL+"\',";
      stStr += "\'"+isModule+"\'";
      stStr += ")";
      stmt.executeQuery(stStr);
    }catch(SQLException ex){
      System.out.println("Error during insert statemenof Object:"+ex+
			 ":"+stStr);
    }
  }


  public void saveConnectionTableInDataBase(String sourceObjectID,
		    	    String eventRef,String targetObjectID,
			    String targetMethod,String typeOfConnection)
  {
    String stStr=null;
    try{
      java.sql.Statement stmt = jdbc_connection.createStatement();
      stStr = "insert into connections_table values(";
      stStr += "\'"+sourceObjectID+"\', ";
      stStr += "\'"+targetObjectID+"\', ";
      stStr += "\'"+eventRef+"\', ";
      stStr += "\'"+targetMethod+"\', ";
      stStr += "\'"+typeOfConnection+"\' ";
      stStr += ")";
      stmt.executeQuery(stStr);
    }catch(SQLException ex){
      System.out.println("Error during insert statemen of Connections:"+ex+
			 ":"+stStr);
    }
  }

  //Delete from database
 public void deleteConnectionTableInDataBase(String sourceObjectID,
		    	    String eventRef,String targetObjectID,
			    String targetMethod,String typeOfConnection)
  {
    String stStr=null;
    try{
      java.sql.Statement stmt = jdbc_connection.createStatement();
      stStr = "delete from connections_table where ";
      stStr += " sourceID=\'"+sourceObjectID+"\' AND ";
      stStr += " targettID=\'"+targetObjectID+"\' AND ";
      stStr += " eventID=\'"+eventRef+"\' AND ";
      stStr += " targetMethod=\'"+targetMethod+"\' AND ";
      stStr += " typeOfConnection=\'"+typeOfConnection+"\' ";
      stmt.executeQuery(stStr);
    }catch(SQLException ex){
      System.out.println("Error during insert statemen of Connections:"+ex+
			 ":"+stStr);
    }
  }

  public void deleteObjectInDatabase(String objectID)

  {
    String stStr="";
    try{
      java.sql.Statement stmt = jdbc_connection.createStatement();
      //delete from objects table
      stStr = "delete from objects_table where ";
      stStr += " OID=\'"+objectID+"\' OR";
      stStr += " parentID=\'"+objectID+"\'";
      stmt.executeQuery(stStr);

      //delete the entries related to attributes table
      stStr = "delete from attributes_table where ";
      stStr += " OID=\'"+objectID+"\'";
      stmt.executeQuery(stStr);

      //delete corresponding entries in connections table
      stStr = "delete from connections_table where ";
      stStr += " sourceID=\'"+objectID+"\' OR";
      stStr += " targettID=\'"+objectID+"\'";
      stmt.executeQuery(stStr);
    }catch(SQLException ex){
      System.out.println("Error during insert statemen of Connections:"+ex+
			 ":"+stStr);
    }

  }
  
   //saveCase : binary or ascii
  //here componenetID is just the name of module not its full path
  public void savePropertiesWithJDBC(String tableName,
				     org.omg.CORBA.Object bcc_obj)
				     				  
  { 

 
    BeanContextChild bcc = BeanContextChildHelper.narrow(bcc_obj);

    //get the name of product
    String childID = bcc.getObjectID();
    String componentID = childID.substring(childID.lastIndexOf("/")+1);
    Element childNode    = (Element)moduleList.get(componentID);
    System.out.println("savePropertiesWithJDBC for :"+componentID+
		       " table:"+moduleList);
    Element propertyNode = getNode(childNode,"properties");
    Hashtable table = getAllProperties(propertyNode);
    if (table == null)
      return ;

    try{
      PreparedStatement pstmt;
      pstmt = jdbc_connection.prepareStatement(
			"insert into attributes_table values (?,?,?,?,?,?)");
      pstmt.setString(1, childID); //componentID);

      for(Enumeration props = table.elements();props.hasMoreElements();){
	String xmlFragment = "";
	Element next = (Element)props.nextElement();
	String attID = next.getAttribute("attID");
	String tagName = next.getTagName();
	pstmt.setString(2,attID);
	System.out.println("tagName:"+tagName);
	
	//remove last 3 letter from simpleDef to get "simple"
	String basicType = tagName.substring(0,tagName.length()-3);
	System.out.println("basicType:"+basicType);
	Element simple = getNode(next,basicType);
	String attName = simple.getAttribute("name");
	pstmt.setString(3,attName);
	System.out.println("attName:"+attName);
	
	//get wrapper interface id
	Element wrapper = getNode(next,"wrapper_interface");
	String wrapperID = wrapper.getFirstChild().getNodeValue();
	pstmt.setString(4,wrapperID);
	
	String binaryVal = getModuleAnyAttribute(bcc,attName, wrapperID);
	pstmt.setString(5,binaryVal);
	
	String xmlValue = getModuleXmlAttribute(bcc,attName, wrapperID);
	xmlFragment  += xmlValue;
	pstmt.setString(6,xmlValue);
	pstmt.executeUpdate();
      }
     
    }catch(SQLException ex){
      System.out.println("Error during insert statemenof attributed:"+ex);
    }
  }
   
  //saveCase : binary or ascii
  //here componenetID is just the name of module not its full path
  public String saveXMLProperties(String saveCase,
				  org.omg.CORBA.Object bcc_obj)
				  
  {
    BeanContextChild bcc = BeanContextChildHelper.narrow(bcc_obj);

    //get the name of product
    String childID = bcc.getObjectID();
    String componentID = childID.substring(childID.lastIndexOf("/")+1);

    String xmlFragment = "<propertyInstances>\n";
    Element childNode    = (Element)moduleList.get(componentID);
    System.out.println("saveXMLProperties:childNode:"+childNode+
		       " for :"+componentID+" table:"+moduleList);
    Element propertyNode = getNode(childNode,"properties");
    Hashtable table = getAllProperties(propertyNode);
    if (table == null)
      return "";

    for(Enumeration props = table.elements();props.hasMoreElements();){
      Element next = (Element)props.nextElement();
      String attID = next.getAttribute("attID");
      String tagName = next.getTagName();
      System.out.println("tagName:"+tagName);

      //remove last 3 letter from simpleDef to get "simple"
      String basicType = tagName.substring(0,tagName.length()-3);
      System.out.println("basicType:"+basicType);
      Element simple = getNode(next,basicType);
      String attName = simple.getAttribute("name");
      System.out.println("attName:"+attName);

      //get wrapper interface id
      Element wrapper = getNode(next,"wrapper_interface");
      String wrapperID = wrapper.getFirstChild().getNodeValue();

      if (saveCase.equals("binary")){
	xmlFragment  += "<propertyVal attrRef=\""+attID+"\">\n";
	String binaryVal = getModuleAnyAttribute(bcc,attName, wrapperID);
	System.out.println("wrapperID:"+wrapperID+" binaryVal:"+binaryVal);
	xmlFragment  += "<binaryVal>"+binaryVal+"</binaryVal>\n";
	xmlFragment  += "</propertyVal>\n";
      }
      else if  (saveCase.equals("ascii")){
	String xmls = getModuleXmlAttribute(bcc,attName, wrapperID);
	xmlFragment  += xmls;
      }
    }
    xmlFragment += "</propertyInstances>\n";
    return xmlFragment;
  }

  public String getModuleAnyAttribute(BeanContextChild server,
				      String attName,String wrapperID)
  {
    org.omg.CORBA.TypeCode typeCode_;
    String opname = "_get_"+attName;
    System.out.println("getModuleAnyAttribute sent method:"+opname);

    org.omg.CORBA.Request _ob_req = server._request(opname);
    typeCode_ = orb_.create_interface_tc(wrapperID, "Object");
    _ob_req.set_return_type(typeCode_);
    _ob_req.invoke();

    java.lang.Exception _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
    org.omg.CORBA.Any _ob_ra = _ob_req.return_value();
    //Now get wrapper object and get the value attribute
    org.omg.CORBA.Object wrapperObj = _ob_ra.extract_Object();

    //now get the attribute value in Any format
    opname = "getNewValue";
    _ob_req = wrapperObj._request(opname);
    typeCode_ = orb_.get_primitive_tc(org.omg.CORBA.TCKind.tk_any);
    _ob_req.set_return_type(typeCode_);
    _ob_req.invoke();

    _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
    _ob_ra = _ob_req.return_value();
    //Now get real value of attribute in any
    org.omg.CORBA.Any anyValue = _ob_ra.extract_any();
    String stringOfProperty =  propertyInAscii(anyValue);
    return stringOfProperty;
  }

  public String getModuleXmlAttribute(BeanContextChild server,
				      String attName,String wrapperID)
  {
    System.out.println("getModuleXmlAttribute called with attname:"+attName+
			" wrapperID:"+wrapperID);

    org.omg.CORBA.TypeCode typeCode_;
    String opname = "_get_"+attName;
    System.out.println("getModuleAnyAttribute sent method:"+opname);

    org.omg.CORBA.Request _ob_req = server._request(opname);
    typeCode_ = orb_.create_interface_tc(wrapperID, "Object");
    _ob_req.set_return_type(typeCode_);
    _ob_req.invoke();

    java.lang.Exception _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
    org.omg.CORBA.Any _ob_ra = _ob_req.return_value();
    //Now get wrapper object and get the value attribute
    org.omg.CORBA.Object wrapperObj = _ob_ra.extract_Object();

    //now get the attribute value in Any format
    opname = "parseXmlValue";
    _ob_req = wrapperObj._request(opname);
    typeCode_ = orb_.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
    _ob_req.set_return_type(typeCode_);
    _ob_req.invoke();

    _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
    _ob_ra = _ob_req.return_value();
    //Now get real value of attribute in any
    String xmls = _ob_ra.extract_string();
    return xmls;
  }


  public String propertyInAscii(org.omg.CORBA.Any anyValue)
  {
    //test
//	String ss = anyValue.extract_string();
 //  	System.out.println("HHRRRRRR:"+ss);
    //test

    org.omg.CORBA.portable.OutputStream os = orb_.create_output_stream();
  
    os.write_any(anyValue);
    org.omg.CORBA.portable.InputStream is = os.create_input_stream();

    String buf="";
    boolean flag=true;
    while(flag)
      {
        try{
          byte b = is.read_octet();
	  String s = Converter.byteToAscii(b);
	  buf += s;
        }catch(java.lang.ArrayIndexOutOfBoundsException ex){
          break;
        }
      }
    System.out.println("Value :"+buf);
    return buf;
  }

 public void setModuleAsciiAttribute(String basicType, Element nextPropVal, 
				     BeanContextChild server, 
				     String attName, String wrapperID)
  {  
    int nvalues = 0;
    NodeList simpleVals = nextPropVal.getElementsByTagName("simpleVal");
    if (simpleVals != null)
      nvalues = simpleVals.getLength();
    String []values = new String[nvalues];
    for(int k=0;k<nvalues;k++){
      Element nextVal = (Element)simpleVals.item(k);
      String simpleVal = nextVal.getFirstChild().getNodeValue();
      values[k] = simpleVal;
    }

    nvalues = 0;
    simpleVals = nextPropVal.getElementsByTagName("sequenceVal");
    if (simpleVals != null)
      nvalues = simpleVals.getLength();
    int[] dims = new int[nvalues];
    for(int k=0;k<nvalues;k++){
      Element nextVal = (Element)simpleVals.item(k);
      dims[k] = numOfChildren(nextVal);
    }

    //now invoke necessary methods
    setAsciiAttribute(values, dims, server, attName,wrapperID, basicType);
  }

  public int numOfChildren(Element node)
  {
    int nchilds=0;
    for(Node next=node.getFirstChild();next != null;
	next=next.getNextSibling())
   {
        String tag = next.getNodeName();
	if ((tag.equals("sequenceVal"))||
            (tag.equals("structVal"))||
            (tag.equals("simpleVal")))  
		nchilds++;
    }
    return nchilds;
  }

  public void  setAsciiAttribute(String[] values, int[] dims,
				       BeanContextChild server,String attName,
				       String wrapperID,String basicType)
  {
    org.omg.CORBA.TypeCode typeCode_;
    String opname = "_get_"+attName;

    org.omg.CORBA.Request _ob_req = server._request(opname);
    typeCode_ = orb_.create_interface_tc(wrapperID, "Object");
    _ob_req.set_return_type(typeCode_);
    _ob_req.invoke();

    java.lang.Exception _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
    org.omg.CORBA.Any _ob_ra = _ob_req.return_value();
    //Now get wrapper object and get the value attribute
    org.omg.CORBA.Object wrapperObj = _ob_ra.extract_Object();

    //update the first letter of basicType to capital
    //simple->Simple, struct ->Struct
    char fc = Character.toUpperCase(basicType.charAt(0));
    basicType = String.valueOf(fc)+basicType.substring(1); 

    //now get the attribute value in Any format
    opname = "parse"+basicType+"Value";
    _ob_req = wrapperObj._request(opname);
    //add the attbute value
    if (basicType.equals("Simple")){
      org.omg.CORBA.Any _ob_aa0 = _ob_req.add_in_arg();
      _ob_aa0.insert_string(values[0]);
    }
    else{
      org.omg.CORBA.Any _ob_aa0 = _ob_req.add_in_arg();
      stringArrayHelper.insert(_ob_aa0, values);
      org.omg.CORBA.Any _ob_aa1 = _ob_req.add_in_arg();
      longArrayHelper.insert(_ob_aa1, dims); 
    }
    _ob_req.invoke();

    System.out.println("setNeValueinConfing after invoke...");

    _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
  }



  public static void  setModuleAnyAttribute( org.omg.CORBA.Any propVal,
				       BeanContextChild server,String attName,
				       String wrapperID)
  {
    org.omg.CORBA.TypeCode typeCode_;
    String opname = "_get_"+attName;

    org.omg.CORBA.Request _ob_req = server._request(opname);
    typeCode_ = orb_.create_interface_tc(wrapperID, "Object");
    _ob_req.set_return_type(typeCode_);
    _ob_req.invoke();

    java.lang.Exception _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
    org.omg.CORBA.Any _ob_ra = _ob_req.return_value();
    //Now get wrapper object and get the value attribute
    org.omg.CORBA.Object wrapperObj = _ob_ra.extract_Object();

    //now get the attribute value in Any format
    opname = "setNewValue";
    _ob_req = wrapperObj._request(opname);
    //add the attbute value
    org.omg.CORBA.Any _ob_aa0 = _ob_req.add_in_arg();
    _ob_aa0.insert_any(propVal);
    _ob_req.invoke();

     System.out.println("setNeValueinConfing after invoke...");

    _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
  }


  public  static org.omg.CORBA.Any propertyInAny(String stringValue)
  {
    System.out.println("propertyInAny is scalled with :"+stringValue+" o:"+orb_);
    org.omg.CORBA.portable.OutputStream os = orb_.create_output_stream();
    byte []bys = Converter.asciiToOctets(stringValue);
    System.out.println("propertyInAny bys ln:"+bys.length);
    for(int k=0;k<bys.length;k++){
      byte val = bys[k];
      os.write_octet(val);
    }
    System.out.println("propertyInAny after loop.");

    org.omg.CORBA.portable.InputStream is = os.create_input_stream();
    System.out.println("propertyInAny is:"+is);
    org.omg.CORBA.Any any = is.read_any();
    return any;
  }

  public Hashtable getAllProperties(Element propertyNode)
  {
     System.out.println("getAllProperties :"+propertyNode);
     if (propertyNode == null)
       return null;

     NodeList simpleProps = propertyNode.getElementsByTagName("simpleDef");
     NodeList sequenceProps=propertyNode.getElementsByTagName("sequenceDef");
     NodeList structProps = propertyNode.getElementsByTagName("structDef");

     Hashtable table = new Hashtable();
     for(int k=0;(simpleProps!=null)&&k<simpleProps.getLength();k++){
       Element next = (Element)simpleProps.item(k);
       String attID = next.getAttribute("attID");
       table.put(attID, next);
     }
     for(int k=0;(sequenceProps!=null)&&k<sequenceProps.getLength();k++){
       Element next = (Element)sequenceProps.item(k);
       String attID = next.getAttribute("attID");
       table.put(attID, next);
     }
     for(int k=0;(structProps!=null)&&k<structProps.getLength();k++){
       Element next = (Element)structProps.item(k);
       String attID = next.getAttribute("attID");
       table.put(attID, next);
     }
     return table;
  }

  public Element filterMyPropInstance(String componentID)
  {
    System.out.println("filterMyPropInstance:search for:"+componentID);
    NodeList instances = rootDocument.getElementsByTagName("ModuleInstance");
    for(int k=0;k<instances.getLength();k++){
      Element next = (Element)instances.item(k);
      Element moduleIDNode = getNode(next,"moduleID");
      String moduleID = moduleIDNode.getFirstChild().getNodeValue();
      System.out.println("filterMyPropInstance:moduleID:"+moduleID);

      if (componentID.equals(moduleID))
	return next;
    }
    return null;
  }

public static Element getNode(Element parent, String nodeTag)
   {
     Node next=null;
     for(next=parent.getFirstChild();next!=null;next=next.getNextSibling()){
       Node node = next;
       int type = node.getNodeType();
       if (type != Node.ELEMENT_NODE)
	 continue;
       Element elem = (Element)node;
       if (elem.getTagName().equals(nodeTag))
	 break;
     }
     return (Element)next;
   }

  //Here componentID is ful path of DN of module :uc1/uc2/hello
   public void restoreXMLProperties(org.omg.CORBA.Object bcc_obj,
					String componentID)
  {
    System.out.println("restoreXMLProperties in config:"+
		       componentID+" called");
     BeanContextChild bcc = BeanContextChildHelper.narrow(bcc_obj);
    //get module instances
    Element myInstance = filterMyPropInstance(componentID);
    String moduleName = componentID.substring(componentID.lastIndexOf("/")+1);
    Element childNode    = (Element)moduleList.get(moduleName);
    Element propertyNode = getNode(childNode,"properties");
    Hashtable propertyTable = getAllProperties(propertyNode);
 
    Element inode = getNode(myInstance,"propertyInstances");
    //there are no property instances
    if (inode == null)
      return;
    NodeList propVals = inode.getElementsByTagName("propertyVal");

    for(int k=0;k<propVals.getLength();k++){
      Element nextPropVal = (Element)propVals.item(k);
      String attRef = nextPropVal.getAttribute("attrRef");

      Element next = (Element)propertyTable.get(attRef);
      String attID = next.getAttribute("attID");
      String tagName = next.getTagName();

      //remove last 3 letter from simpleDef to get "simple"
      String basicType = tagName.substring(0,tagName.length()-3);
      Element simple = getNode(next, basicType);
      String attName = simple.getAttribute("name");

      //get wrapper interface id
      Element wrapper = getNode(next, "wrapper_interface");
      String wrapperID = wrapper.getFirstChild().getNodeValue();
      
      Element jnode =  getNode(nextPropVal,"binaryVal");
      //extract binary property value
      if (jnode != null){
	String binaryVal = jnode.getFirstChild().getNodeValue();
	org.omg.CORBA.Any propVal = propertyInAny(binaryVal);
	setModuleAnyAttribute(propVal,bcc, attName, wrapperID);
      }
      //extract ascii property value in text form
      //it can be "simpleVal", "structVal" or "sequenceVal"
      else{
	setModuleAsciiAttribute(basicType,nextPropVal, bcc, 
				attName, wrapperID);
      }

    }
  }
  

    public void getIRString()
    {
      org.omg.CORBA.Object IRobj=null;
      try{
	IRobj = orb_.resolve_initial_references("InterfaceRepository");
      }catch(org.omg.CORBA.ORBPackage.InvalidName ex){
	System.out.println("Error in getting IR IOR in configReader:"+ex);
      }
      String IRstr = orb_.object_to_string(IRobj);
      this.IRstr = IRstr;
    }

public String getWFSName ()
{
	return ServerName;
}


public boolean isTheServerRunnning()
  {
     //check first is there any WebFlow server running around
    
    org.omg.CORBA.Object wfProcess = readIOR(orb_, localFile);
    boolean res_non_existent = true;
    if (wfProcess == null)
      return non_existent;

    try{
      //res_non_existent = wfProcess._non_existent();
	 res_non_existent = WebFlow.ProxyImpl.nonExistent(wfProcess);
    }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
    catch(org.omg.CORBA.COMM_FAILURE ex){}
    non_existent = res_non_existent;
    return non_existent;
    
  }


public boolean writeGatewayIOR(org.omg.CORBA.Object masterGateway)
  {
    //If I am master, don't do anything
    if (localFile.equals("none"))
      return false;

    //check first is there any WebFlow server running around
    org.omg.CORBA.Object wfProcess = readIOR(orb_, localFile);
    boolean non_exist = true;

    try{
      //non_exist = wfProcess._non_existent();
      non_exist = WebFlow.ProxyImpl.nonExistent(wfProcess);
    }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
     catch(org.omg.CORBA.COMM_FAILURE ex){}
     catch(java.lang.NullPointerException ex){}

    //there is no gateway server running around...
    if (non_exist){
      writeIORtoFile(localFile, masterGateway);
      return non_exist;
    }
    else{
      System.out.println("We have already one GateWay Server running around ...");
      return non_exist;
    }
  }


public void writeIORtoFile(String refFile, org.omg.CORBA.Object gwserver)
{
	try
	{
		String ref = orb_.object_to_string(gwserver);
 		FileOutputStream file = new FileOutputStream(refFile);
		PrintWriter out = new PrintWriter(file);
		out.println(ref);
		out.flush();
		file.close(); 
	 }
	 catch(IOException ex)
	 {
		System.err.println("Can't write to `" +  ex.getMessage() + "'");
		System.exit(1);
	 }
}

public  static org.omg.CORBA.Object readIOR(org.omg.CORBA.ORB orb ,String fn)
{
    String ref = null;
    try
      {
	String refFile = fn;//"Hello.ref";
	FileInputStream file = new FileInputStream(refFile);
	BufferedReader in =
	  new BufferedReader(new InputStreamReader(file));
	ref = in.readLine();
	file.close();
      }
    catch(IOException ex)
      {
	System.err.println("Can't read from `" +
			   ex.getMessage() + "'");
	return null;
	//System.exit(1);
      }
    
    org.omg.CORBA.Object obj = orb.string_to_object(ref);
    return obj;
        
  }


public void getIORFromURL(String url)
{
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
   
      /*
	//register myselt to master as a slave
	System.out.println("Slave WebFlow :register himself as slave to"+masterServerIOR);
	WebFlowContext master = WebFlowContextHelper.narrow(orb_.string_to_object(masterServerIOR));
	//master =  WebFlowContextHelper.narrow(master.getNamedContext(parentName));

	System.out.println("Slave WebFlow :after read master IOR:"+master);
	String objectID = parentName+"/"+ServerName;
	ServerName = objectID;
	master.insertRemoteServer(ServerName,objectID,server_);
	//master.addWFServer(ServerName, server_);
	System.out.println("Slave WebFlow :sent addWFServer request");
	*/
}


public boolean  setFileURLName(String pair)
{
	int k = pair.indexOf("=");
	String attr = pair.substring(0, k);
      String val  = pair.substring(k+1);
	System.out.println("configReader : got attr: "+attr+" val :"+val+"/");

	if (attr.equals("File")){
         localFile = val;
	 if (!val.equals("none")){
	   isItMaster = true;
	   return isTheServerRunnning();
	   //writeIORtoFile(val, server_);
	 }
  	}
	else if (attr.equals("URL")){
	    masterURL = val;			
	    //if (localFile.equals("none"))
	    //getIORFromURL(val);		
	}
	else if (attr.equals("ServerName")){
	    ServerName = val;
	}
	else if (attr.equals("PARENT")){
	    parentName = val;
	    if (localFile.equals("none") && (!parentName.equals("none") )){
	      isItMaster = false;
	      getIORFromURL(masterURL);
	      
	    }
	}
	return true;
}

public boolean isMaster()
{
  return isItMaster;
}

public Hashtable getConfig()
  {
    return configTable;
        
  }

public String getImplClass(String mouduleOrEventName)
  {
    interfaceAndImpl impl ;
    impl = (interfaceAndImpl)configTable.get(mouduleOrEventName);
    return (impl.implClassName_);
       
  }
  
public String getIdlFileName(String mouduleOrEventName)
  {
    interfaceAndImpl impl ;
    impl = (interfaceAndImpl)configTable.get(mouduleOrEventName);
    return ((impl == null)?null:impl.idlFileName_);
  }

    public void addWFServer(String name, org.omg.CORBA.Object server)
	{
		WFServers.put(name, server);
	}
    
    public void removeWFServer(String name)
	{
		WFServers.remove(name);
	}

	public  String[] getAllWFServers()
	{
		int k;
		Enumeration e;
		Enumeration keys = WFServers.keys();
		String []servers = new String[WFServers.size()];
		for (k=0 ; keys.hasMoreElements();k++) 
		    servers[k]= (String)keys.nextElement();
		return servers;
	}

	public org.omg.CORBA.Object getWFServer(String name)
	{
		org.omg.CORBA.Object ref = (org.omg.CORBA.Object)WFServers.get(name);
		return ref;
	}			

}
