package WebFlow.util;

import WebFlow.event.*;
import WebFlow.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import org.omg.CORBA.*;
import java.net.*;
import WebFlow.xml.*;
import org.w3c.dom.*;
import java.sql.*;

public class install {

   public static Document  root;
   public static org.omg.CORBA.Object server;
   public static Hashtable moduleTable;
   public static org.omg.CORBA.ORB orb;
  public static org.omg.CORBA.Object []ms = new org.omg.CORBA.Object[30];
  public static int cnt=0;
   public static Connection jdbc_conn;
   public static configReaderImpl creader;
  public static int OBJECT_AND_PROXY = 1;
  public static int ONLY_OBJECT      = 2;
  public static int ONLY_PROXY       = 1;
  public static String xmlFileName;
  public static WebFlowContext master;

   public static void  main (String []args)
   {
     int argslen = args.length;
     String fromWhere = args[0];
     orb = ORB.init(args, new java.util.Properties());

     if (fromWhere.equals("-file")){
       String xmlfileName = args[1];
       install installer = new install(xmlfileName);
       installer.makeInstall();
     }
     else if (fromWhere.equals("-jdbc")){
       creader = new configReaderImpl(orb);
       makeInstallFromDataBase(null);
     }
     else if (fromWhere.equals("-fix")){
       creader = new configReaderImpl(orb);
       String xmlfileName = args[1];
       fixFailuredObjects(xmlfileName);
       return;
     }
     
     waitForInput();
   }

  //For fixing
   public install ()
  {
    String []args={""};
    orb = ORB.init(args, new java.util.Properties());
    creader = new configReaderImpl(orb);
    master = getMaster();
  }

   public static String  waitForMaster(String masterURL)
   {
     String ref=null;
     org.omg.CORBA.Object obj=null;
     boolean flag=true;
     while(flag){
       ref = getIORFromURL(masterURL);
       System.out.println("Got ior :"+ref);
       obj = orb.string_to_object(ref);
       boolean non_exist = true;
       try{
	 non_exist = obj._non_existent();
       }catch(org.omg.CORBA.COMM_FAILURE ex){}
        catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
       
       if (!non_exist)
	 flag = false;
       try{
	 Thread.sleep(500);
       }catch(InterruptedException ex){
       }
     }
     System.out.println("waitForMaster after while loop..");
     return ref;
  }

   public install (org.omg.CORBA.Object server, String xmlFileName)
   {

     this.server = server;
     moduleTable  = new Hashtable();

     Document document=null;
     try{
        DOMParser parser = new DOMParser();
        root = parser.parse(xmlFileName);
     }catch (Exception e) {
        e.printStackTrace(System.err);
        return;
     }

     //store the IOR of WebFlow server in DOM tree
     NodeList elements = root.getElementsByTagName("WebFlowContext");
     Element outerContext = (Element)elements.item(0);

     //ORB:transform to IOR
     String contextIOR = orb.object_to_string(server);
     //String contextIOR ="";
     ms[cnt++] =  server;
     outerContext.setAttribute("ior", contextIOR);
     master = getMaster();
   }

   public install (String xmlFileName)
   {
     this.xmlFileName =xmlFileName;
     moduleTable  = new Hashtable();

     Document document=null;
     try{
        DOMParser parser = new DOMParser();
        root = parser.parse(xmlFileName);
     }catch (Exception e) {
        e.printStackTrace(System.err);
        return;
     }
     creader = new configReaderImpl(orb, root);
     master = getMaster();
   }


  //get connections or Attributes table from Oracle Database
  public static Hashtable getConnAttTable(String request)
  {
    Hashtable tableInfo = new Hashtable();
    jdbc_conn = creader.connectToDataBase("akarsu","akarsu");
    Statement stmt = null;
    //first get connection table
    try{
       stmt = jdbc_conn.createStatement();
       ResultSet results = stmt.executeQuery(request);
       ResultSetMetaData rsmd = results.getMetaData(); 
       int numColumns = rsmd.getColumnCount();

       while(results.next()){
	 String []row = new String[numColumns];
	 for(int k=0;k<numColumns;k++){
	   row[k] = results.getString(k+1);
	   row[k] = row[k].trim();
	 }
	 String objectID = row[0];
	 Vector ce = (Vector)tableInfo.get(objectID);
	 if (ce == null){
	   ce = new Vector();
	   tableInfo.put(objectID, ce);
	 }
	 ce.add(row);
       }
       stmt.close();
    }catch(SQLException ex){
       System.out.println("There is problem in makeInstallFromDataBase:"+ex);
    }
    return tableInfo; 
  }
   
   //get Objects table from Oracle Database
  public static Hashtable getObjectTable(String request)
  {
    Hashtable tableInfo = new Hashtable();
    jdbc_conn = creader.connectToDataBase("akarsu","akarsu");
    Statement stmt = null;
    //first get connection table
    try{
       stmt = jdbc_conn.createStatement();
       ResultSet results = stmt.executeQuery(request);
       ResultSetMetaData rsmd = results.getMetaData(); 
       int numColumns = rsmd.getColumnCount();

       while(results.next()){
	 String []row = new String[numColumns];
	 for(int k=0;k<numColumns;k++){
	   row[k] = results.getString(k+1);
	   row[k] = row[k].trim();
	 }
	 String objectID = row[0];
	 tableInfo.put(objectID, row);
       }
       stmt.close();
    }catch(SQLException ex){
       System.out.println("There is problem in makeInstallFromDataBase:"+ex);
    }
    return tableInfo;
  }

  public static WebFlowContext getMaster()
  {
     String request = "select * from objects_table where parentID = \'null\'";
     Hashtable table = getObjectTable(request);
     java.lang.Object [] vl = table.values().toArray();
     String[] oinfo = (String [])vl[0];
     String remoteIOR = oinfo[3];
     org.omg.CORBA.Object po =  orb.string_to_object(remoteIOR);
     return WebFlowContextHelper.narrow(po);
  }

  public static WebFlowContext getRemoteMaster()
  {
     String request = "select * from objects_table where parentID = \'null\'";
     Hashtable table = getObjectTable(request);
     java.lang.Object [] vl = table.values().toArray();
     String[] oinfo = (String [])vl[0];
     String remoteIOR = oinfo[2];
     org.omg.CORBA.Object po =  orb.string_to_object(remoteIOR);
     return WebFlowContextHelper.narrow(po);
  }

   public static void makeInstallFromDataBase(
					org.omg.CORBA.Object masterServer)
   {
     //first get connection table
     // connections table
     // sourceID , targetID ,eventID , targetMethod, typeOfConnection
     // ========   ========  =======   ============  ================
     String request = "select * from connections_table";
     Hashtable connections_list = getConnAttTable(request);
     
     //Second get attributes table
     //attributes table
     //objectID , attID ,attName , wrapperID, binary_value, xml_value 
     //========   =====  =======   =========  ============  ========= 
     //now set attributes if any
     request = "select * from attributes_table";
     Hashtable attributes_list = getConnAttTable(request);
            
     //third install objects
     //Second get objecs table
     //objects  table
     //OID ,      parentID ,ObjecttIOR, ProxyIOR   installerURL  isModule
     //========   =====     =======     =========  ========      ========
     /////////////////////////////
     request = "select * from objects_table";
     //first read all objects and put them into a list and sort it
     Hashtable object_hash_list = getObjectTable(request);
     //sort it
     java.lang.Object[] objects_list =  sortObjectList(object_hash_list);

     org.omg.CORBA.Object obj = null;
     comparator comp = new comparator();
     int size = objects_list.length;
     for(int k=0;k<size;k++){
       String []row = (String[])objects_list[k];
       String objectID = row[0];
       Vector attList = (Vector)attributes_list.get(objectID);
       String parentID = row[1];
	 
       String []keyArray = new String[1];
       keyArray[0] = parentID;
       int parentIndex = Arrays.binarySearch(objects_list,keyArray,comp);
       System.out.println("makeInstallFromDataBase:pind:"+parentIndex);
       
       //get master
       String []myParent;
       WebFlowContext master;
       //If object is module
       int numColumns = row.length;
       if (row[numColumns-1].equals("M")){
	 myParent = (String [])objects_list[parentIndex];
	 master = getMasterObject(objects_list);
	 obj = installModuleFromJDBC(master, OBJECT_AND_PROXY,row,
				     attList,myParent);
       }
       else if (row[numColumns-1].equals("C")){
	 String installerURL = row[4];
	 if (!installerURL.equals("null")){
	   String objIOR = executeURL(installerURL);
	   obj = orb.string_to_object(objIOR);
	   storeOuterServerInDB(obj);
	 }
	 else{
	   myParent = (String [])objects_list[parentIndex];
	   master = getMasterObject(objects_list);
	   obj = installContextFromJDBC(master, OBJECT_AND_PROXY,row,
				       attList,myParent);
	 }
       }
       else
	 System.out.println("makeInstallFromDataBase: unknown indicator"+
			      row[numColumns-1]);

       row[2] = orb.object_to_string(obj);
       objects_list[k] = row;
     }
       
     Hashtable newObjList = toHashTable(objects_list);

     //forth make connection among objects
     makeConnectionsFromDataBase(connections_list, newObjList, null, null);
     
   }

  //We have found the object with objectID "failureObjectID" is down
  //Now we fill read all of objects from Database and fix both proxy and 
  //remote object of WebFlow modules.
   public static void fixFailuredObjects(String failureObjectID)
   {
     //first get connection table
     // sourceID , targetID ,eventID , targetMethod, typeOfConnection
     // ========   ========  =======   ============  ================
     String request = "select * from connections_table";
     Hashtable connections_list = getConnAttTable(request);
     
     //Second get attributes table
     //objectID , attID ,attName , wrapperID, binary_value, xml_value 
     //========   =====  =======   =========  ============  ========= 
     //now set attributes if any
     request = "select * from attributes_table";
     Hashtable attributes_list = getConnAttTable(request);
            
     //objects  table
     //OID ,      parentID ,ObjecttIOR,   ProxyIOR,  installerURL isModule
     //========   =====     =======       =========  ========      ========
     /////////////////////////////
     request = "select * from objects_table";
     //first read all objects and put them into a list and sort it
     Hashtable object_hash_list = getObjectTable(request);
     //sort it
     java.lang.Object[] objects_list =  sortObjectList(object_hash_list);


     boolean[] isCreated = new boolean[1];
     org.omg.CORBA.Object remoteObj=null, proxyObj=null; 
     //Go through all objects in WebFlow system.
     //We make exhaustive check of all objects because the error may affect
     //any number of objects, we don't know.
     Hashtable new_module_list = new Hashtable();
     Hashtable new_context_list = new Hashtable();
     int size = objects_list.length;
     for(int k=0;k<size;k++){
       String []objInfo = (String[])objects_list[k];
       String objectID = objInfo[0];
       Vector attList = (Vector)attributes_list.get(objectID);

       remoteObj = fixRemoteObject(objInfo, attList,
				   objects_list,isCreated);
       if (isCreated[0]){
	 if (objInfo[objInfo.length-1].equals("M")) // it is module
	   new_module_list.put(objInfo[0], remoteObj);
	 else  //it is a context
	   new_context_list.put(objInfo[0], remoteObj);

	 //update possible modified IORs of remote and proxy objects
	 objects_list[k] = objInfo; 
       }
     }
     
     Hashtable newObjList = toHashTable(objects_list);
     //Now, fix disconnection associations among user modules
     makeConnectionsFromDataBase(connections_list, newObjList,
				 new_module_list, new_context_list);
   }

  public static WebFlowContext getMasterObject(java.lang.Object[] objects_list)
  {
    String []objInfo = (String[])objects_list[0];
    String proxyIOR  = objInfo[3];
    org.omg.CORBA.Object obj = orb.string_to_object(proxyIOR);
    WebFlowContext wfc = WebFlowContextHelper.narrow(obj);
    return wfc;
  }


  public static WebFlowContext parentObject(String objectID,
				       java.lang.Object[] objects_list)
  {
    String []row = parentInfo(objectID, objects_list);
    org.omg.CORBA.Object obj = orb.string_to_object(row[3]);
    WebFlowContext wfc = WebFlowContextHelper.narrow(obj);
    return wfc;
  }

  public static String[] parentInfo(String objectID,
			       java.lang.Object[] objects_list)
  {
    comparator comp = new comparator();
    String []keyArray = new String[1];
    keyArray[0] = objectID;
    int parentIndex = Arrays.binarySearch(objects_list,keyArray,comp);
    if (parentIndex < 0){
      System.out.println("Sorry , I could not find the object info in"+
			  " data base for object with ID:"+objectID);
      return null;
    }
    String []row = (String[])(objects_list[parentIndex]);
    return row;
  }

  public static org.omg.CORBA.Object fixRemoteObject(String []objInfo,
					      Vector attributes,
					      java.lang.Object[] objects_list,
					      boolean[] isCreated)
  {
    String objectID  = objInfo[0];
    String objectIOR = objInfo[2];
    String proxyIOR  = objInfo[3];
    String installer = objInfo[4];
    org.omg.CORBA.Object remoteObj = orb.string_to_object(objectIOR);
    org.omg.CORBA.Object proxyObj = orb.string_to_object(proxyIOR);
    boolean isra = isRemoteAlive(remoteObj);
    boolean ispa = isProxyAlive(proxyObj);
    System.out.println("fixRemoteObject:objectID:"+objectID+" isra:"+
		       isra+" ispa:"+ispa);
    if (isra && ispa){
      System.out.println("objectID: P&R are ALIVE..");
      isCreated[0] = false;
      return proxyObj;
    }
    
    System.out.println("fixRemoteObject:installer:"+installer+
		       " objectID:"+objectID);
    //if the object is outmost WebFlow context, start it through 
    //a URL-addressible servlet
    if ((!installer.equals("null")) &&((!ispa)||(!isra))){
      System.out.println("fixRemoteObject:starting servlet for:"+objectID);
      String objIOR = executeURL(installer);
      isCreated[0]  = true;
      org.omg.CORBA.Object obj = orb.string_to_object(objIOR);
      storeOuterServerInDB(obj);
      System.out.println("fixRemoteObject:RECOVERED :"+objectID);
      return obj;
    }

    int create_flag = OBJECT_AND_PROXY;
    if ((!isra) && ispa)
      create_flag = ONLY_OBJECT;
    else if (isra && (!ispa))
      create_flag = ONLY_PROXY;
       
    WebFlowContext master = getMasterObject(objects_list);
    org.omg.CORBA.Object newObj=null;
    String[] pinfo = parentInfo(objectID,objects_list); 
    String isModule =  objInfo[5];
    if (isModule.equals("M")){
      System.out.println("fixRemoteObject:recover fromDB Module:"+objectID);
      newObj = installModuleFromJDBC(master, create_flag,objInfo,
				     attributes,pinfo);
    }
    else if (isModule.equals("C")){
      System.out.println("fixRemoteObject:recover fromDB Context:"+objectID);
      newObj = installContextFromJDBC(master,create_flag,objInfo,
				      attributes,pinfo);
    }
    
    //if we create new proxy, then we will update all of connection tables
    if (create_flag == ONLY_OBJECT)
      isCreated[0]  = false;
    else
      isCreated[0]  = true;
    return newObj;
  }

  public static void storeOuterServerInDB(org.omg.CORBA.Object server)
  {
    //proxy
    BeanContextChild proxyObj = BeanContextChildHelper.narrow(server);
    //get peer
    org.omg.CORBA.Object peerObj = proxyObj.getBeanContextChildPeer();
    String proxyIOR = orb.object_to_string(proxyObj);
    String peerIOR  = orb.object_to_string(peerObj);
    String objectID = proxyObj.getObjectID();

    try{
       //update my entry to reflect my IOR
       Statement stmt = jdbc_conn.createStatement();
       String request = "UPDATE objects_table  SET objectIOR = \'"+
	 peerIOR+"\', proxyIOR = \'"+proxyIOR+ 
	 "\' where OID = \'"+objectID+"\'";
       System.out.println("storeOuterServerInDB:request:"+request);

       ResultSet results = stmt.executeQuery(request);
       System.out.println("storeOuterServerInDB:updateCnt:"+
			   stmt.getUpdateCount());
     }catch(SQLException ex){
       System.out.println("There is problem in installContextFromJDBC:"+ex);
     } 


  }


  //
  // IDL:isRemoteAlive
  //
  public static boolean
  isRemoteAlive(org.omg.CORBA.Object _ob_a0)
  {
    org.omg.CORBA.Request _ob_req = master._request("isRemoteAlive");
    
    org.omg.CORBA.Any _ob_aa0 = _ob_req.add_in_arg();
    _ob_aa0.insert_Object(_ob_a0);
    
    _ob_req.set_return_type(orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
    
    _ob_req.invoke();
    
    java.lang.Exception _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;
       
    org.omg.CORBA.Any _ob_ra = _ob_req.return_value();
    return _ob_ra.extract_boolean();
  }

 public static boolean isProxyAlive( org.omg.CORBA.Object obj)
  {
    boolean non_exist = true;
    try{
      non_exist = obj._non_existent();
    }catch(org.omg.CORBA.COMM_FAILURE ex){}
    catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
    catch(org.omg.CORBA.INV_OBJREF ex){}
    catch(java.lang.NullPointerException ex){ }
    return (!non_exist);
  }

  public static Hashtable toHashTable(java.lang.Object []list)
  {
    Hashtable table = new Hashtable();
    int size = list.length;
    for(int k=0;k<size;k++){
       String[] item = (String[])list[k];
       String objectID = item[0];
       table.put(objectID, item);
    }
    return table;
  }


  public  static java.lang.Object []sortObjectList(Hashtable objects_list)
  {
    java.lang.Object []raw_list = objects_list.values().toArray();
    Arrays.sort(raw_list, new comparator());

    System.out.println("OID-parentID---");
    for(int k=0;k<raw_list.length;k++){
      String[] item = (String[])raw_list[k];
      System.out.println(item[0]+"    -     "+item[1]);
    }
    return raw_list;
  }

  public static String  executeURL(String url) {
        String masterServerIOR="";
        String thisLine=null;
	try {
	  URL u = new URL(url);
	  // now turn the URL into a DataInputStream
	  try {
	    DataInputStream theHTML = new DataInputStream(u.openStream());
	    try {
	      while ((thisLine = theHTML.readLine()) != null) {
		masterServerIOR += thisLine;
	      } // while loop ends here
	    }catch (Exception e) {
	      System.out.println("executeURL:"+e);
	    }
	  }catch (Exception e) {
	    System.out.println("executeURLRL:"+e);
	  }

	}catch (MalformedURLException e) {
	  System.out.println("executeURL:"+e);
	}
	System.out.println("executeURL returns:"+masterServerIOR);
	return masterServerIOR;
  }

  public static void
    setRemoteObject(org.omg.CORBA.Object proxyObj, org.omg.CORBA.Object _ob_a0)
    {
        org.omg.CORBA.Request _ob_req = proxyObj._request("setRemoteObject");

        org.omg.CORBA.Any _ob_aa0 = _ob_req.add_in_arg();
        _ob_aa0.insert_Object(_ob_a0);

        _ob_req.invoke();

        java.lang.Exception _ob_ex = _ob_req.env().exception();
        if(_ob_ex != null)
            throw (org.omg.CORBA.SystemException)_ob_ex;
    }


    public static org.omg.CORBA.Object 
    installModuleFromJDBC(WebFlowContext master, int create_flag,
			  String []mentry,Vector attList,String []myParent)
    {
      System.out.println("installModuleFromJDBC is called..:"+create_flag);
      
     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj =  orb.string_to_object(myParent[3]);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
    
     //add new module
     String objectID = mentry[0];
     org.omg.CORBA.Object new_module=null;
     String compRef = objectID.substring(objectID.lastIndexOf("/")+1);
     System.out.println("installModuleFromJDBC:adding new module:"+compRef);

     if (create_flag == OBJECT_AND_PROXY){
       System.out.println("installModuleFromJDBC:OBJECT_AND_PROXY");
       new_module = parentContext.addNewModule(compRef);
     }
     else if (create_flag == ONLY_OBJECT){
       System.out.println("installModuleFromJDBC:ONLY_OBJECT");
       //mentry[3] holds proxyIOR
       new_module = orb.string_to_object(mentry[3]);
       BeanContextChild bcc = BeanContextChildHelper.narrow(new_module);
       obj = parentContext.createOnlyModule(compRef);
       bcc.setMyProxy(obj);
     }
     else if (create_flag == ONLY_PROXY){
       System.out.println("installModuleFromJDBC:ONLY_PROXY");
       //mentry[2] holds objectIOR and mentry[0] object ID
       obj = orb.string_to_object(mentry[2]);
       new_module = master.insertRemoteServer("failureModule", mentry[0], obj);
     }

     String proxyIOR = orb.object_to_string(new_module);
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_module);
     obj = bcc.getBeanContextChildPeer();
     String new_moduleIOR = orb.object_to_string(obj);
     System.out.println("installModuleFromJDBC:after create module..");

     try{
       //update my entry to reflect my IOR
       Statement stmt = jdbc_conn.createStatement();
       String request = "UPDATE objects_table  SET objectIOR = \'"+
	 new_moduleIOR+"\', proxyIOR = \'"+proxyIOR+ 
	 "\' where OID = \'"+objectID+"\'";
       ResultSet results = stmt.executeQuery(request);
       System.out.println("installModuleFromJDBC:updateCnt:"+
			   stmt.getUpdateCount());

     }catch(SQLException ex){
       System.out.println("There is problem in installModuleFromJDBC:"+ex);
     }  

     mentry[2] = new_moduleIOR;
     mentry[3] = proxyIOR;

     //return instantiated object
     if (attList == null)
       return new_module; 

     
     System.out.println("installModuleFromJDBC:before get atts.:"+attList);
     //attributes table
     //objectID , attID ,attName , wrapperID, binary_value, xml_value 
     //========   =====  =======   =========  ============  ========= 
     //now set attributes if any
     bcc = BeanContextChildHelper.narrow(new_module);
     for(int k=0;k<attList.size();k++){
       String []arow   = (String[])attList.elementAt(k);
       String attName   = arow[2]; //attName field 
       String wrapperID = arow[3]; //wrapperID field;
       String binaryVal  = arow[4]; //binary_value field
       System.out.println("installModuleFromJDBC:after get atts.");
       org.omg.CORBA.Any propVal=creader.propertyInAny(binaryVal);
       creader.setModuleAnyAttribute(propVal,bcc,attName,wrapperID);
       System.out.println("installModuleFromJDBC:after installed atts.");
     }
     System.out.println("installModuleFromJDBC:after for loop..");
     
     //return instantiated object
     return new_module;
   }
 
    public static org.omg.CORBA.Object 
    installContextFromJDBC(WebFlowContext master,int create_flag, 
			   String []mentry,Vector attList,String[] myParent)
   {

     System.out.println("installContextFromJDBC is called..");
     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj =  orb.string_to_object(myParent[3]);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     
     //add new context
     String objectID = mentry[0];
     org.omg.CORBA.Object new_context=null;
     try{

       if (create_flag == OBJECT_AND_PROXY)
	 new_context = parentContext.addNewContext(objectID);
       else if (create_flag == ONLY_OBJECT){
	 //mentry[3] holds proxyIOR
	 new_context = orb.string_to_object(mentry[3]);
	 BeanContextChild bcc = BeanContextChildHelper.narrow(new_context);
	 obj = parentContext.createOnlyContext(objectID);
	 bcc.setMyProxy(obj);
       }
       else if (create_flag == ONLY_PROXY){
	 //mentry[2] holds objectIOR and mentry[0] object ID
	 obj = orb.string_to_object(mentry[2]);
	 new_context = master.insertRemoteServer("failureModule", 
						mentry[0], obj);
       }
       // new_context = parentContext.addNewContext(objectID);
     }catch(PropertyVetoException e){
       System.out.println("Install context:"+e);System.exit(0);}
     catch(WebFlow.NullPointerException e){
       System.out.println("Install context:"+e);System.exit(0);}


     String proxyIOR = orb.object_to_string(new_context);
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_context);
     obj = bcc.getBeanContextChildPeer();
     String new_contextIOR = orb.object_to_string(obj);
     System.out.println("installContextFromJDBC:after create module..");

     try{
       //update my entry to reflect my IOR
       Statement stmt = jdbc_conn.createStatement();
       String request = "UPDATE objects_table  SET objectIOR = \'"+
	 new_contextIOR+"\', proxyIOR = \'"+proxyIOR+ 
	 "\' where OID = \'"+objectID+"\'";
       System.out.println("installContextFromJDBC:request:"+request);
       
       ResultSet results = stmt.executeQuery(request);
       System.out.println("installContextFromJDBC:updateCnt:"+
			   stmt.getUpdateCount());
     }catch(SQLException ex){
       System.out.println("There is problem in installContextFromJDBC:"+ex);
     } 

     //update remote and proxy object IORs
     mentry[2] = new_contextIOR;
     mentry[3] = proxyIOR;

     //return new context object
     return new_context;
   }

   public static void makeConnectionsFromDataBase(Hashtable connections_list, 
						  Hashtable objects_list,
						  Hashtable new_module_list, 
						  Hashtable new_context_list)
   {
     org.omg.CORBA.Object sourceObj,targetObj;
     //Objects-table
     // OID , parentID , objectIOR
     // ===   ========   =========
     for(Enumeration e=objects_list.elements();e.hasMoreElements();){
       System.out.println("makeCon:begon for loop");

       String []orow = (String[])e.nextElement();
       String objectID = orow[0];
       sourceObj = orb.string_to_object(orow[2]);
       System.out.println("makeCon:begon for loop for:"+objectID);

       String parentID = orow[1];
       String []pelem = (String[])objects_list.get(parentID);
       //if my parent ios null, that I am root, then continue
       if (pelem == null)
	 continue;

       String parentIOR = pelem[2];
       org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
       WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);


       // connections table
       // sourceID , targetID ,eventID , targetMethod, typeOfConnection
       // ========   ========  =======   ============  ================

       Vector ce = (Vector)connections_list.get(objectID);
       if (ce == null)
	 continue;

       for(int k=0;k<ce.size();k++){
	 String []crow = (String[])ce.elementAt(k);
	 String targetID = crow[1];

	 String[] tpinfo = (String [])objects_list.get(targetID);
	 String targetParentID = tpinfo[1];
	 //If this method is called from fix.. method, we will restore
	 //only disconnections 
	 //if the context object of source or target is restored
	 //or If source and target object is restored, 
	 //then restore the connections
	 if ((new_module_list != null)&&(new_context_list!=null) &&
	     (!new_module_list.containsKey(objectID))&&
	      (!new_context_list.containsKey(parentID))&&
	      (!new_module_list.containsKey(targetID))&& 
	      (!new_context_list.containsKey(targetParentID)))
	   continue;


	 pelem = (String[])objects_list.get(targetID);
	 targetObj = orb.string_to_object(pelem[2]);
	 String eventRef  = crow[2];
	 String targetMethod = crow[3];
	 String connectMode = crow[4];
	 System.out.println("Establish this conne:targetID:"+targetID+
		     " connectMode:"+connectMode+" eventRef:"+eventRef+
			    " targetMethod:"+targetMethod);
 
	 if (connectMode.equals("push"))
	   parentContext.attachPushEvent(sourceObj,eventRef,
					 targetObj,targetMethod);
	 else if (connectMode.equals("pull"))
	   parentContext.attachPullEvent(sourceObj,eventRef,
					 targetObj);
       }
     }
   }


   public static  void makeInstall()
   {
     Hashtable entityFlagTable = new Hashtable();
     makeInstall_ex(root,entityFlagTable);
     makeConnection();
   }

   public static void makeInstall_ex(Node root, Hashtable entityFlagTable )
   {
       Element next;
       NodeList list = root.getChildNodes();
       for(int k=0;k<list.getLength();k++){
	 Node node = list.item(k);  
	 int type = node.getNodeType();
	 if ((type != Node.ELEMENT_NODE) &&
	     (type != Node.ENTITY_REFERENCE_NODE))
	   continue;
	 System.out.println("makeInstall_ex:"+node.getNodeName());
     	 String tag = node.getNodeName(); 
	 if (tag.equals("WebFlowContext")){
	   next = (Element)node;
	   installContext(next);
	   makeInstall_ex(next,entityFlagTable );
	 }
	 else if (tag.equals("ModuleInstance")){
	   next = (Element)node;
	   installModule(next,entityFlagTable);
	 }
	 else if (tag.equals("moduleImpl")){
	   next = (Element)node;
	   entityFlagTable.put(next.getAttribute("componentRef"),
			       next.getAttribute("entityFlag"));
	   System.out.println(next.getAttribute("componentRef")+":"+
			      next.getAttribute("entityFlag"));
	 }
	 else
	   makeInstall_ex(node,entityFlagTable);

       }
   }
    
   public static Element getNode(Element parent, String nodeTag)
   {
     Node next=null;
     for(next=parent.getFirstChild();next!=null;next=next.getNextSibling()){
       Node node = next;
       int type = node.getNodeType();
       if (type != Node.ELEMENT_NODE)
	 continue;
       Element elem = (Element)node;
       if (elem.getTagName().equals(nodeTag))
	 break;
     }
     return (Element)next;
   }

   public static void installContext(Element contextNode)
   {
    
     System.out.println("installContext:"+contextNode);

     //create now new context
     String ID = contextNode.getAttribute("componentID");
     System.out.println("Install context:"+ID);

     //ORB:transform to IOR
     org.omg.CORBA.Object new_context=null;
     String installerURL = contextNode.getAttribute("servlet_href");
     System.out.println("Install installerURL:"+installerURL);

     String entityFlag = contextNode.getAttribute("entityFlag");
     //If WebFlow Context is outermost context
     if (installerURL.length() > 0){
       System.out.println("Install URL.."+installerURL);
       String objIOR = executeURL(installerURL);
       new_context = orb.string_to_object(objIOR);
     }
     //else if it is inner context
     else{
       System.out.println("Install inner context..");
       Element parent = (Element)contextNode.getParentNode();
       String parentIOR = parent.getAttribute("ior");
       org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
       WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
       try{
	 new_context = parentContext.addNewContext(ID);
       }catch(PropertyVetoException e){
	 System.out.println("Install context:"+e);System.exit(0);}
       catch(WebFlow.NullPointerException e){
	 System.out.println("Install context:"+e);System.exit(0);}
     }
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_context);
     if (entityFlag.equals("yes")){
       bcc.setEntityFlag(true);
       bcc.saveObjectInDataBase();
     }
     else if (entityFlag.equals("no"))
       bcc.setEntityFlag(false);

     String next_contextIOR = orb.object_to_string(new_context);
     //String next_contextIOR="";

     //set my IOR
     contextNode.setAttribute("ior", next_contextIOR);

     //add it into object list
     System.out.println(cnt+":"+ID);
     ms[cnt++] = new_context;
   }

   public static void installModule(Element moduleNode, 
				    Hashtable entityFlagTable)
   {
     Element parent = (Element)moduleNode.getParentNode();

     //obtain parent WebFlow context
     String parentIOR = parent.getAttribute("ior");
     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     
     //create now new Module
     //get componentRef Node
     Element compRefNode = getNode(moduleNode, "componentRef");
     String compRef = compRefNode.getFirstChild().getNodeValue();
     Element modeIDNode = getNode(moduleNode, "moduleID");
     String moduleID = modeIDNode.getFirstChild().getNodeValue();
     System.out.println("installModule:compRef:"+compRef+" modeID:"+moduleID);

      //ORB:transform to IOR
     org.omg.CORBA.Object new_module=null;
     new_module = parentContext.addNewModule(compRef);
     String next_moduleIOR = orb.object_to_string(new_module);

     //If module is enttity moduel, save its state during its construction
     String entityFlag = (String)entityFlagTable.get(compRef);
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_module);
     if (entityFlag.equals("yes")){
       bcc.setEntityFlag(true);
       bcc.saveObjectInDataBase();
     }
     else if (entityFlag.equals("no"))
       bcc.setEntityFlag(false);

     //add it into object list
     System.out.println(cnt+":"+moduleID);
     ms[cnt++] = new_module;
     
     //set my IOR
     moduleNode.setAttribute("ior", next_moduleIOR);
     //add new instantiated module into table for connecting events
     //ORB:put the module reference to table
     moduleTable.put(moduleID, new_module); 
     //moduleTable.put(modeID, "");

     //now set attributes if any
     bcc = BeanContextChildHelper.narrow(new_module);
     //bcc.restoreXMLProperties();
     //test
     creader.restoreXMLProperties(bcc, moduleID);
     //test
   }

  public static void makeConnection()
   {
     NodeList connections = root.getElementsByTagName("connect");
     for(int k=0;k<connections.getLength();k++)
       {
	 org.omg.CORBA.Object sourceObj,targetObj;
	 
	 Element connect = (Element)connections.item(k);
	 String connectMode =  connect.getAttribute("typeOfConnection");
	 String eventRef =  connect.getAttribute("eventRef");
	 System.out.println("makeConnection:connectMode:"+connectMode+
			    " eventRef:"+eventRef);

	 Element parent = (Element)connect.getParentNode().getParentNode();
	 //obtain parent WebFlow context
	 String parentIOR = parent.getAttribute("ior");
	 //System.out.println("makeConnection:parentIor:"+parentIOR);
	 //ORB:transform from IOR to CORBA Object
	 org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
	 WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
	
	 //find source
	 Element source = getNode(connect, "sourceObject");
	 Element moduleRefNode = getNode(source, "moduleRef");
	 String  sourceModuleRef = moduleRefNode.getFirstChild().getNodeValue();
	 //ORB:get source reference from table
	 sourceObj = (org.omg.CORBA.Object)moduleTable.get(sourceModuleRef);
	 

	 System.out.println("sourceModuleRef :"+sourceModuleRef);
 
         //find target
	 Element target = getNode(connect, "targetObject");
	 moduleRefNode = getNode(target, "moduleRef");
	 String targetModuleRef = moduleRefNode.getFirstChild().getNodeValue();
	 //ORB:get target reference from table
	 targetObj = (org.omg.CORBA.Object)moduleTable.get(targetModuleRef);
	 System.out.println("targetModuleRef :"+targetModuleRef);

	 //find target method
	 Node targetMethodNode;
	 targetMethodNode = getNode(target, "targetMethod");
	 String targetMethod = targetMethodNode.getFirstChild().getNodeValue();
	 System.out.println("targetMethod :"+targetMethod);

	 //check second parameter of XpushX and XPullX methods?????????
	 //ORB:not the time to make connection
	 if (connectMode.equals("push"))
	   parentContext.attachPushEvent(sourceObj,eventRef,
					 targetObj,targetMethod);
	 else if (connectMode.equals("pull"))
	   parentContext.attachPullEvent(sourceObj,eventRef,
					 targetObj);
       }
   }
 
   
  public static String  getIORFromURL(String url) 
  {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
	try {
	  URL u = new URL(url);
	  // now turn the URL into a DataInputStream
	  try {
	    DataInputStream theHTML = new DataInputStream(u.openStream());
	    try {
	      while ((thisLine = theHTML.readLine()) != null) {
		masterServerIOR += thisLine;
	      } // while loop ends here
	    }  // end try
	    catch (Exception e) {
	      System.out.println("install:getIORfromURL:"+e);
	    }
	  } // end try
	  catch (Exception e) {
	    System.out.println("install:getIORfromURL:"+e);
	  }

	} // end try
	catch (MalformedURLException e) {
	  System.out.println("install:getIORfromURL:"+url + 
			     " is not a parseable URL");
	  System.out.println("install:getIORfromURL:"+e);
	}
	return masterServerIOR;
  }
  

public static void waitForInput()
  {
    String input;
    boolean flag=true;
    
    do
      {
	try{
	System.out.print(">>>> ");
	DataInputStream dataIn = new DataInputStream(System.in);
	BufferedReader in =
	  new BufferedReader(new InputStreamReader(dataIn));
	input = in.readLine();
	System.out.println("You entered :"+input);

	if(input.indexOf("d") == 0){
	  //int c = Integet.parseInt(input.substring(1,1));
	  int index_1 = input.indexOf("-");
	  int index_2 = input.lastIndexOf("-");
	  int ci = Integer.parseInt(input.substring(1,index_1));
	  int mi = Integer.parseInt(input.substring(index_1+1,index_2));
	  int mj = Integer.parseInt(input.substring(index_2+1));
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);

	  System.out.println("Client: Detaching property p1-k1");
	  wfc.detachPushEvent(ms[mi],"timeElapsed",ms[mj],"getTime");
	}
	if(input.indexOf("rc") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1));
	  System.out.println("Client: Remove context:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.removeContext(ms[mi]);
	}
	
	if(input.indexOf("rm") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1));
	  System.out.println("Client: Remove child:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.removeModule(ms[mi]);
	}
	if(input.indexOf("cm") == 0){
	  int index = input.indexOf("-");
	  int lindex = input.lastIndexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1,
						    lindex));
	  int mj = Integer.parseInt(input.substring(lindex+1));
	  System.out.println("Client: Remove child:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.copyModuleBinding(ms[mi], ms[mj]);
	}
	if(input.indexOf("ci") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  String name = input.substring(index+1);
	  System.out.println("Client: Change Impl of :"+ci+" with:"+name);
	  BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
	  bcc.changeImpl(name);
	}
	if(input.indexOf("ri") == 0){
	  int ci = Integer.parseInt(input.substring(2));
	  System.out.println("Client: Remoev itself of :"+ci);
	  BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
	  bcc.removeMyself();
	}
	if(input.indexOf("li") == 0){
	  int ci = Integer.parseInt(input.substring(2));
	  System.out.println("Client: List :"+ci);
	  listContents(ms[ci]);
	}
	//xmlb : save as binary... xmla: save as ascii xml file
	if(input.indexOf("xml") == 0){
	  char  cc = input.charAt(3);
	  String saveCase="";
	  if (cc == 'b')
	    saveCase = "binary";
	  else if (cc == 'a')
	    saveCase = "ascii";

	  int ci = Integer.parseInt(input.substring(4));
	  System.out.println("Client: xml :"+ci);
	  WebFlowContext wfc=WebFlowContextHelper.narrow(ms[ci]);
	  if (saveCase.length() > 0){
	    String xmlFragment = wfc.saveStateInXml(saveCase);
	    System.out.println(wfc.getObjectID()+
			     " got this XML Document:"+xmlFragment);
	  }
	  else // save in database through JDBC
	       wfc.saveStateInDataBase();
	}
	}catch(Exception e){}
      }while(flag);
    
}

static public void listContents(org.omg.CORBA.Object context)
  {
    WebFlowContext wfc = WebFlowContextHelper.narrow(context);
    System.out.println("This Context has the following childs:"+
			wfc.getObjectID());
    org.omg.CORBA.Object []list = wfc.toArray();
     System.out.println("This Context has :"+list.length+" children..");
    for(int k=0;k<list.length;k++){
      BeanContextChild bcc = BeanContextChildHelper.narrow(list[k]);
      String id = bcc.getObjectID();
      System.out.println("Next child:"+id);
    }


  }
 
}
 class comparator implements Comparator{

  public int compare(java.lang.Object o1, java.lang.Object o2)
    {
      String[] ol1 = (String[])o1;
      String[] ol2 = (String[])o2;

      String ID_1 = ol1[0];
      String ID_2 = ol2[0];
      return ID_1.compareTo(ID_2);
    }
  }


