package WebFlow;
import WebFlow.event.*;

import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import org.omg.CORBA.*;
import java.net.*;
import WebFlow.xml.*;

import org.w3c.dom.*;


//Read configuration file which looks like this:
//Module/Event Name -----  IDL fileName ----- Implementation Class
//Read this file and store it into "configTable"

public class configReaderImpl_xml extends _configReaderImplBase
{
    private Hashtable configTable;
    //The table for idl files of all modules and events interface idls
    private Vector idlFiles;
    private org.omg.CORBA.ORB orb_;
    Hashtable WFServers;
    public org.omg.CORBA.Object server_;
    public String localFile, masterURL, ServerName,ServerID;
    public boolean  non_existent=true ;
    public String parentName;
    public boolean isItMaster;
    public String masterServerIOR;
    public String xmlFileName_,IRstr,idlFilesDir;
    
    public class interfaceAndImpl
    {
	public  String idlFileName_,implClassName_;
	public  String flag_;
    
	public interfaceAndImpl(String flag,String idlFileName,
			   String implClassName)
			
	{
	    flag_          = flag;
	    idlFileName_   = idlFileName;
	    implClassName_ = implClassName;
	}
    } //public class interfaceAndImpl

    public String[] getModuleList()
    {
	Vector vmodules = new Vector();
	for(Enumeration list=configTable.elements();list.hasMoreElements();){
	    interfaceAndImpl val = (interfaceAndImpl)list.nextElement();
	    if (val.flag_.equals("Module"))
		vmodules.addElement(val);
	}
	String[]  modules = new String[vmodules.size()];
	vmodules.copyInto(modules);
	return modules;
	
    }

    public configReaderImpl_xml(org.omg.CORBA.Object server, 
			    ORB orb, String xmlFileName)
    {
      server_ = server;
      orb_ = orb;
      xmlFileName_ = xmlFileName;
      //later uncomment
      getIRString();

      Document document=null;
      try{
	DOMParser parser = new DOMParser();
	document = parser.parse(xmlFileName);
      }catch (Exception e) {
	e.printStackTrace(System.err);
	return;
      }
      //get preorder traversal of all onfigFile ELEMENTs
      NodeList elements = document.getElementsByTagName("configFile");
      for(int k=0;k<elements.getLength();k++)
	installConfigFiles(elements.item(k));
    }

    public void   installConfigFiles(Node configElement)
    {
      //create table to keep available WebFlow Servers
      WFServers  = new Hashtable();
      configTable = new Hashtable();
      idlFiles    = new Vector();

      //get componentID and servlet_href attributes
      //component ID like this:a/b/c/ServerName
      Element wfc = (Element)configElement.getParentNode();
      ServerID   = wfc.getAttribute("componentID");
      int index  = ServerID.lastIndexOf("/");
      ServerName = ServerID.substring(index+1);
      if (index <0)
	index = ServerID.length();
      parentName = ServerID.substring(0,index);

      System.out.println("Servername:"+ServerName+" serverid:"+ServerID);
      //if servername and serverID is equal, 
      //the context holding this configFile is behaves as a master

      //get first child of configFile element:it is master or slave
      Node status_node = configElement.getFirstChild().getNextSibling();
      Element status = (Element)status_node;
   
      idlFilesDir = status.getAttribute("idlFilesDir");
      System.out.println("idlFilesDir:"+idlFilesDir);
      String tagname = status.getTagName();
      if (tagname.equals("master")){
	localFile = status.getAttribute("localFile");
	System.out.println("I am master:localFile:"+localFile);
	//if there is one server running, then return
	//Uncommment later
	if (!isTheServerRunnning())
	  return;
	isItMaster = true;
      }
      else if (tagname.equals("slave")){
	System.out.println("I am slave..");
	masterURL = status.getAttribute("masterURL");
	isItMaster = false;
	//Uncommment later
	getIORFromURL(masterURL);
      }
      irfeedIdlFiles((Element)configElement);
    }  

    public void irfeedIdlFiles(Element configElement )
  {
      NodeList modules = configElement.getElementsByTagName("UserModule");
      NodeList impls= configElement.getElementsByTagName("implementation");

      System.out.println("modulesLen:"+modules.getLength()+
			 "-implsLen:"+impls.getLength());

      Element  implnode = (Element)impls.item(0);
      NodeList moduleImpls   = implnode.getElementsByTagName("moduleImpl");
      Hashtable moduleList = new Hashtable();

      for(int k=0;k<modules.getLength();k++){
	Element next = (Element)modules.item(k);
	String nextModuleName = next.getAttribute("componentID");
	moduleList.put(next.getAttribute("componentID"), next);
      }

      for(int k=0;k<moduleImpls.getLength();k++){
	Element nextImpl = (Element)moduleImpls.item(k);
	String moduleName = nextImpl.getAttribute("componentRef");
	String implClassName = nextImpl.getAttribute("implClass");

	Element nextModule = (Element)moduleList.get(moduleName);
	String idlFileName   = nextModule.getAttribute("idlFile");
	System.out.println("CONFIG="+moduleName+"="+idlFileName+"="
			     +implClassName);
	interfaceAndImpl iai = new interfaceAndImpl("Module",idlFileName,
						    implClassName);
	configTable.put(moduleName,iai);
	//feedOneIDL(idlFileName);

      }

  }

  public void feedOneIDL(String idlFileName)
  {
	 
    //Feed idl interface of this module
    if (idlFiles.indexOf(idlFileName) >= 0)
      return;
    String command = "irfeed -ORBrepository "+IRstr+
      " -I"+idlFilesDir+" "+idlFileName;
			
    try{
      System.out.println("configReader :irfeeding the file:"+idlFileName);
      Process p = Runtime.getRuntime().exec(command);
      p.waitFor();
    }catch (Exception ex){
      System.out.println("Error in feeding IDL file :"+idlFileName+ " : "+ex);
    }
    idlFiles.addElement(idlFileName);
    
  }


    public void getIRString()
    {
      org.omg.CORBA.Object IRobj=null;
      try{
	IRobj = orb_.resolve_initial_references("InterfaceRepository");
      }catch(org.omg.CORBA.ORBPackage.InvalidName ex){
	System.out.println("Error in getting IR IOR in configReader:"+ex);
      }
      String IRstr = orb_.object_to_string(IRobj);
      this.IRstr = IRstr;
    }

public String getWFSName ()
{
	return ServerName;
}


public boolean isTheServerRunnning()
  {
     //check first is there any WebFlow server running around
    
    org.omg.CORBA.Object wfProcess = readIOR(orb_, localFile);
    boolean res_non_existent = true;

    try{
	 res_non_existent = wfProcess._non_existent();
    }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
    catch(org.omg.CORBA.COMM_FAILURE ex){}
    non_existent = res_non_existent;
    return non_existent;
    
  }


public boolean writeGatewayIOR(org.omg.CORBA.Object masterGateway)
  {
    //check first is there any WebFlow server running around
    org.omg.CORBA.Object wfProcess = readIOR(orb_, localFile);
    boolean non_exist = true;

    try{
	 non_exist = wfProcess._non_existent();
    }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
    catch(org.omg.CORBA.COMM_FAILURE ex){}

    //there is no gateway server running around...
    if (non_exist){
      writeIORtoFile(localFile, masterGateway);
      return non_exist;
    }
    else{
      System.out.println("We have already one GateWay Server running around ...");
      return non_exist;
    }
  }


public void writeIORtoFile(String refFile, org.omg.CORBA.Object gwserver)
{
	try
	{
		String ref = orb_.object_to_string(gwserver);
 		FileOutputStream file = new FileOutputStream(refFile);
		PrintWriter out = new PrintWriter(file);
		out.println(ref);
		out.flush();
		file.close();
	 }
	 catch(IOException ex)
	 {
		System.err.println("Can't write to `" +  ex.getMessage() + "'");
		System.exit(1);
	 }
}

public  static org.omg.CORBA.Object readIOR(org.omg.CORBA.ORB orb ,String fn)
{
    String ref = null;
    try
      {
		String refFile = fn;//"Hello.ref";
		FileInputStream file = new FileInputStream(refFile);
		BufferedReader in =
		new BufferedReader(new InputStreamReader(file));
		ref = in.readLine();
		file.close();
      }
    catch(IOException ex)
      {
            System.err.println("Can't read from `" +
                                   ex.getMessage() + "'");
			System.exit(1);
      }
 
    org.omg.CORBA.Object obj = orb.string_to_object(ref);
    return obj;
        
  }


public void getIORFromURL(String url)
{
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
   
      /*
	//register myselt to master as a slave
	System.out.println("Slave WebFlow :register himself as slave to"+masterServerIOR);
	WebFlowContext master = WebFlowContextHelper.narrow(orb_.string_to_object(masterServerIOR));
	//master =  WebFlowContextHelper.narrow(master.getNamedContext(parentName));

	System.out.println("Slave WebFlow :after read master IOR:"+master);
	String objectID = parentName+"/"+ServerName;
	ServerName = objectID;
	master.insertRemoteServer(ServerName,objectID,server_);
	//master.addWFServer(ServerName, server_);
	System.out.println("Slave WebFlow :sent addWFServer request");
	*/
}


public boolean  setFileURLName(String pair)
{
	int k = pair.indexOf("=");
	String attr = pair.substring(0, k);
      String val  = pair.substring(k+1);
	System.out.println("configReader : got attr: "+attr+" val :"+val+"/");

	if (attr.equals("File")){
         localFile = val;
	 if (!val.equals("none")){
	   isItMaster = true;
	   return isTheServerRunnning();
	   //writeIORtoFile(val, server_);
	 }
  	}
	else if (attr.equals("URL")){
	    masterURL = val;			
	    //if (localFile.equals("none"))
	    //getIORFromURL(val);		
	}
	else if (attr.equals("ServerName")){
	    ServerName = val;
	}
	else if (attr.equals("PARENT")){
	    parentName = val;
	    if (localFile.equals("none") && (!parentName.equals("none") )){
	      isItMaster = false;
	      getIORFromURL(masterURL);
	      
	    }
	}
	return true;
}

public boolean isMaster()
{
  return isItMaster;
}

public Hashtable getConfig()
  {
    return configTable;
        
  }

public String getImplClass(String mouduleOrEventName)
  {
    interfaceAndImpl impl ;
    impl = (interfaceAndImpl)configTable.get(mouduleOrEventName);
    return (impl.implClassName_);
       
  }
  
public String getIdlFileName(String mouduleOrEventName)
  {
    interfaceAndImpl impl ;
    impl = (interfaceAndImpl)configTable.get(mouduleOrEventName);
    return ((impl == null)?null:impl.idlFileName_);
  }

    public void addWFServer(String name, org.omg.CORBA.Object server)
	{
		WFServers.put(name, server);
	}
    
    public void removeWFServer(String name)
	{
		WFServers.remove(name);
	}

	public  String[] getAllWFServers()
	{
		int k;
		Enumeration e;
		Enumeration keys = WFServers.keys();
		String []servers = new String[WFServers.size()];
		for (k=0 ; keys.hasMoreElements();k++) 
		    servers[k]= (String)keys.nextElement();
		return servers;
	}

	public org.omg.CORBA.Object getWFServer(String name)
	{
		org.omg.CORBA.Object ref = (org.omg.CORBA.Object)WFServers.get(name);
		return ref;
	}			

}
