
package WebFlow.util;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.ContainedPackage.*;
   
public class irtraverse{
   static ORB orb ;
   static Hashtable interfacedef;
   static  org.omg.CORBA.Repository repository ;
   static String next_idlFile;
   static int numSpaces=2, numHelper=2;
   static Process IRprocess=null;
   static String []idlTable={"void","short","long","ushort","ulong","float",
		     "double","boolean","char","octet","string"};
   static String []javaTable = {"void","short","int","short","int","float",
		     "double","boolean","char","byte","String"};
  static int tempcnt =0,nextdim=0;

   public static void main(String args[])
    {
      
      org.omg.CORBA.Object IRobj=null;
      String refFile = args[0];
      String IRstr   ; //= args[1];

      if (args.length <2){
	System.out.println("java WebFlow.utils.irtraverse xmlFile idlFile");
	return;
      }

      orb = ORB.init(args, new java.util.Properties());
      BOA boa = orb.BOA_init(args, new java.util.Properties());
      interfacedef = new Hashtable();

      IRobj = startIntRep();
      repository = org.omg.CORBA.RepositoryHelper.narrow(IRobj);
     
      //first irfeed the idlFile
      IRstr = orb.object_to_string(IRobj);
      if (IRstr == null){
	System.out.println("I am returning because IT is null");
	return;
      }
      //wait until IR is up
      waitUntil(IRstr);
      
      String xmldoc="";
      int numOfInterfaces = args.length;
      for(int k=1;k<numOfInterfaces;k++)
	{
	  next_idlFile = args[k];
	  String command = "irfeed -ORBrepository "+ IRstr+" "+next_idlFile;
	  try{
	    System.out.println("configReader :irfeeding the file:"+next_idlFile);
	    Process p = Runtime.getRuntime().exec(command);
	    p.waitFor();
	  }catch (Exception ex){
	    System.out.println("Error in feeding IDL file :"+
			       next_idlFile+ " : "+ex);
	  }
	  //now look at attributes
	  xmldoc += traverse(repository);
	}
       System.out.println("I transformed all idl files to XML document");
       writeXMLDoc(refFile, xmldoc);

       //IRprocess.destroy();
    }

public static void waitUntil(String ref)
  {
    boolean flag=true;
    while(flag){
      org.omg.CORBA.Object obj = orb.string_to_object(ref);
      boolean non_exist = true;
      try{
	non_exist = obj._non_existent();
      }catch(org.omg.CORBA.COMM_FAILURE ex){}
      catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
      
      if (!non_exist)
	flag = false;
      try{
	Thread.sleep(500);
      }catch(InterruptedException ex){   }
    }
  }


public static org.omg.CORBA.Object startIntRep()
  {
	String ref=null ;
	printProcessOut ppo;
	org.omg.CORBA.Object IRobj=null;

	System.out.println("start interface Repository");
	String command = "irserv --ior";
	try{
	 Process p = Runtime.getRuntime().exec(command);
	 ppo = new printProcessOut(p);
         IRprocess = p;
	 ref = ppo.getIOROfProcess();
	 System.out.println("WebFlow server got IOR of IR:"+ref);
	 ppo.startProcess(); 
	}catch (Exception ex){
		 System.out.println("Error in starting ModuleFactory in Proxy:"+ex);
	}

	IRobj = orb.string_to_object(ref);
	System.out.println("WebFlow server connected to IR:"+IRobj);
	((com.ooc.CORBA.ORB)orb).add_initial_reference("InterfaceRepository", IRobj);
	System.out.println("WebFlow server connected to IR");
	return IRobj;
 }	

  public static String baseInterface(InterfaceDef att_idef)
  {
     InterfaceDef []base_idefs = att_idef.base_interfaces();
     InterfaceDef top_idef = base_idefs[0];
     
     FullInterfaceDescription  fullInterfaceDesc=null;
     fullInterfaceDesc = top_idef.describe_interface(); 
     String id = fullInterfaceDesc.id;
     return id ;
}

 public static boolean whichAttribute(InterfaceDef att_idef, String baseID)
  {
    FullInterfaceDescription  fullInterfaceDesc;
    InterfaceDef []base_idefs = att_idef.base_interfaces();
    for(int k=0;k<base_idefs.length;k++){
      InterfaceDef next_idef = base_idefs[k];
      fullInterfaceDesc = next_idef.describe_interface();
      String next_id = fullInterfaceDesc.id;
      if (next_id.indexOf(baseID) >= 0)
	return true;
    }
    return false;
  }

  
 public static String typeStr (int kindVal)
       //AttributeDescription simpleAtt)
  {
    //int kindVal = simpleAtt.type.kind().value();
    String type=null;
    switch(kindVal){
    case org.omg.CORBA.TCKind._tk_void: type="void";break; 
    case org.omg.CORBA.TCKind._tk_short: type="short";break;
    case org.omg.CORBA.TCKind._tk_long: type="long";break;  
    case org.omg.CORBA.TCKind._tk_ushort: type="ushort";break;
    case org.omg.CORBA.TCKind._tk_ulong: type="ulong";break;  
    case org.omg.CORBA.TCKind._tk_float: type="float";break;
    case org.omg.CORBA.TCKind._tk_double: type="double";break;   
    case org.omg.CORBA.TCKind._tk_boolean: type="boolean";break;
    case org.omg.CORBA.TCKind._tk_char: type="char";break; 
    case org.omg.CORBA.TCKind._tk_octet: type="octet";break;
    case org.omg.CORBA.TCKind._tk_string: type="string";break;
    case org.omg.CORBA.TCKind._tk_objref:type="objref";break;
    case org.omg.CORBA.TCKind._tk_alias:type="alias";break;  
    case org.omg.CORBA.TCKind._tk_sequence:type="sequence";break;
    case org.omg.CORBA.TCKind._tk_struct:type="struct";break;
    }
    if (type == null)
      System.out.println("typeStr:This attribute is no SIMPLE:"+kindVal);
    return type;
  }

public static String insertSimple(String type, String repositoryID ,
				  String attname, String usagename,
				   boolean isXml, String[] parseStmt)
  {
    String simpProp = "";
    
    if (isXml){
      simpProp += putSpace(0);
      simpProp += "<simple type=\""+type+"\" name=\""+attname+"\">\n";
    
      String description = "this is optional desctiption";
      simpProp += putSpace(1);
      simpProp += "<description>"+description+"</description>\n";
      
      if (repositoryID != null){
	simpProp += putSpace(0);
	simpProp += "<repositoryID>"+repositoryID+"</repositoryID>\n";
      }
      
      simpProp += putSpace(-1);
      simpProp += "</simple> \n";
    }

    //generate parse stmts
    if (repositoryID == null)  
      repositoryID = type;

    parseStmt[0] += makeParseStmt(repositoryID, usagename); //"attValue[]");
    return simpProp;
  }

public static String buildSimpleAttr(InterfaceDef wrapper_idef,
				     AttributeDef attrVal_def,
				     AttributeDescription attrVal_desc,
				     String attname,String usageName,
				     String eventID)
  {
    nextdim = 0;
    //start building start tag
    String attID   = usageName; 
    String stag = putSpace(1);
    stag     += "<simpleDef attID=\""+attID+"\" eventType=\""+eventID+"\">\n";
    String simpProp = stag;

    String wrapper_interface = wrapper_idef.id(); //wrapper_att.id;
    simpProp += putSpace(1);
    simpProp +="<wrapper_interface>"+wrapper_interface+"</wrapper_interface>\n";
    String repositoryID =null;
    int kindVal = attrVal_desc.type.kind().value();
    String type = typeStr(kindVal);
    if (type.equals("objref")){
      try{
        repositoryID = attrVal_def.type().id();
      }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){
	System.out.println("buildSimpleAttr:Ex:"+ex);
      }
    }

    String []parseStmt ={""};
    simpProp += insertSimple(type,repositoryID,attname,"attValue",true,
                             parseStmt);

    simpProp += putSpace(-1);
    simpProp += "</simpleDef>\n";
    //System.out.println("I got a simple attribute :\n"+simpProp);
    putSpace(-1);
    
    //now generate wrapper files to extract and insert the attribute values
    if (repositoryID == null)
      repositoryID = type;
    String transform = generateAttrWrapper(wrapper_interface, 
					   repositoryID,null);

    transform +=  putHelper(0);
    transform += makeParseValueMethod(repositoryID, parseStmt[0]);

    transform += putHelper(-1);
    transform += "}\n";
    String wrapperClassName = getWrapperClassName(wrapper_interface);
    String wrapperClass = wrapperClassName+"Impl";
    writeXMLDoc("attrs/"+wrapperClass+".java", transform);

    return simpProp;
  }

public static IDLType  findTypeFromAlias(AttributeDef attrVal_def)
  {

    AliasDef adef = AliasDefHelper.narrow(attrVal_def.type_def());
    IDLType itype = adef.original_type_def();
    return itype;
  }

public static int  findTypeValFromAlias(IDLType itype)
  {
    org.omg.CORBA.TypeCode tcode = itype.type();
    int tval = tcode.kind().value();
    //System.out.println("kindVal in findTypeFromAlias:"+tval);
    return tval;
  }

 public static String getType(String wrapper)
  {
    int firstColon = wrapper.indexOf(":");
    int lastColon = wrapper.lastIndexOf(":");
    String sub = wrapper.substring(firstColon+1, lastColon);
    String packageName = sub.replace('/', '.');
    System.out.println("package name:"+packageName);
    return packageName;
    
  }
 
public static String buildStructMembers(IDLType idltype, String stname,
					boolean isXml, String []parseStmt,
					boolean isInLoop )
  {
    String simpProp="";
    String newstmt = "";

    StructDef stdef = StructDefHelper.narrow(idltype);
    StructMember []stmems = stdef.members();
    for(int k=0;k<stmems.length;k++){
      StructMember nextMember = stmems[k];
      String memberName = nextMember.name;
      int kindVal = nextMember.type.kind().value();
      IDLType type_def = nextMember.type_def;
      System.out.println("memname:"+memberName+"kindCal:"+kindVal);

      String type = typeStr(kindVal);
      String repositoryID=null ;
      try{
	repositoryID = type_def.type().id();
      }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){
	System.out.println("memname:catch exc:"+ex);
      }
      if (isSimple(kindVal)){
	if ((!isInLoop) || (k !=0))
	  parseStmt[0] += putHelper(0);
	simpProp += insertSimple(type,repositoryID,memberName,
				 "values[next++]",isXml,parseStmt);
	//add this member to parsed statements
	String stdosmem      = stname+"."+memberName;
	newstmt    = stdosmem+" = t_"+String.valueOf(tempcnt-1)+";\n";

	parseStmt[0] += putHelper(0);
        parseStmt[0] += newstmt;
      }
      else{
	if (kindVal == org.omg.CORBA.TCKind._tk_alias){
	  AliasDef adef = AliasDefHelper.narrow(type_def);
          type_def = adef.original_type_def();
	  kindVal = type_def.type().kind().value();
	  type = typeStr(kindVal);
      	}
	if (kindVal == org.omg.CORBA.TCKind._tk_sequence){
	  type = sequenceType(type_def);
	}
        String compname = stname+"."+memberName;
	simpProp += insertNonSimple(type_def, type,repositoryID,
				    memberName,kindVal,
				    compname,isXml, parseStmt);
      }
    }
    return simpProp;
  }


public static String insertDim(String s, int dim)
  {
    int index = s.indexOf("[");
    s = s.substring(0,index+1)+dim+s.substring(index+1);
    return s;
  }

public static String makeParseStmt(String repositoryID, String attValue)
  {
    String jclass="";
    //get java type translation of idl type
    String jtype = javaTypeStr(repositoryID);
    //modify first letter to upper cace
    char fc = Character.toUpperCase(jtype.charAt(0));
    String u_jtype = String.valueOf(fc)+jtype.substring(1); 
    if (u_jtype.equals("Int"))
      jclass = "Integer";
    else
      jclass = u_jtype;
    String parseMethod = jclass+"."+"parse"+u_jtype;
    System.out.println("parseMethod:"+parseMethod);

    String parseValue=null;
    if (jtype.equals("char"))
      parseValue = "String.valueOf("+attValue+".charAt(0))";
    else if (jtype.equals("String"))
      parseValue = attValue;
    else
      parseValue = parseMethod+"("+attValue+")";

    String lhs = "t_"+String.valueOf(tempcnt++);
    String parseStmt  =jtype+" "+lhs+" = "+ parseValue+";\n";
    return parseStmt;
  }  

 public static String getSeqType(String jtype)
  {
    int idlindex = jtype.indexOf("IDL:");
    if (idlindex < 0){
      int pindex = jtype.indexOf("[");
      if (pindex > 0)
        jtype = jtype.substring(0,pindex); 
      return jtype;
    }

    int firstColon = jtype.indexOf(":");
    int lastColon = jtype.lastIndexOf(":");
    String sub = jtype.substring(firstColon+1, lastColon);
    String packageName = sub.replace('/', '.');
    System.out.println("package name:"+packageName);
    return packageName;
    
  }

public static String makeSeqStmt(IDLType type_def, 
	String arrayName, String[] parseStmt)
  {
    int []typeval = new int[1];
    IDLType []btype = new IDLType[1];
    String dimsType = findSeqeunceDim(type_def, typeval,btype);
    System.out.println("makeSeqStmt:Seqeunce :elemType"+dimsType+
		" typeval:"+typeval[0]);  

    String idlelemtype = typeStr(typeval[0]);
    String jtype       = javaTypeStr(dimsType);//elemIdlType);
    String jelemtype   = getSeqType(jtype); //jtype;

    int is = dimsType.indexOf("[");
    int il = dimsType.lastIndexOf("]");
    int ndim = (il-is+1)/2;
    System.out.println("NDIM :"+ndim);

    String []idims = new String[ndim];
    int[] bounds = new int[2*ndim];

    parseStmt[0] += putHelper(0);
    parseStmt[0] += arrayName+"   =  new "+jelemtype;
    for(int k=0;k<ndim;k++){
      bounds[k]     = nextdim;
      idims[k]      = "dims["+(nextdim++)+"]";
      parseStmt[0] += "["+idims[k]+"]"; 
    }

    parseStmt[0] += ";\n";
    parseStmt[0] += putHelper(0);
    for(int d=0;d<ndim;d++){
      parseStmt[0] += "for(int i"+bounds[d]+"=0;i"+bounds[d]+
	    "< "+idims[d]+";i"+bounds[d]+"++)\n";
      if (d + 1 != ndim)
	parseStmt[0] += putHelper(1);
    }

    String arrayacc = arrayName;
    for(int k=0;k<ndim;k++)
      arrayacc += "[i"+bounds[k]+"]";

    parseStmt[0] += putHelper(0);
    parseStmt[0] += "{\n";

    if (isSimple(typeval[0])){
       parseStmt[0] += putHelper(1);
       parseStmt[0] += makeParseStmt(idlelemtype,"values[next++]");
       parseStmt[0] += putHelper(0);
       parseStmt[0] += arrayacc+" = t_"+String.valueOf(tempcnt-1)+";\n";
     }
    //struct type
    else{
      parseStmt[0] += putHelper(1);
      buildStructMembers(btype[0], arrayacc,false, parseStmt,true);
    }
    parseStmt[0] += putHelper(-1);
    parseStmt[0] += "}\n";  
    for(int d=0;d<ndim-1;d++) 
      putHelper(-1);

    return parseStmt[0];
  }

public static String makeStructParseValue(IDLType type_def, 
                               String[] in_parseStmt)
  {

    String parseStmt = "";
    parseStmt += putHelper(-2);
    parseStmt +="public void parseStructValue(String []values, int []dims){\n";
    parseStmt += putHelper(1);
    parseStmt += "int next = 0; \n";
    parseStmt += in_parseStmt[0];
    in_parseStmt[0] = parseStmt;
    return parseStmt;
  }    

public static String makeSeqParseValue(IDLType type_def, 
				       String[] in_parseStmt)
  {
    
    String parseStmt = "";
    parseStmt += putHelper(-2);
    parseStmt += "public void parseSeqValue(String []values, int []dims){\n"; 
    parseStmt += putHelper(1);
    parseStmt += "int next = 0; \n";
    parseStmt += in_parseStmt[0];
    in_parseStmt[0] = parseStmt;
    return parseStmt;
  }

public static String makeParseValueMethod(String repositoryID, String gens)
  {
    String parseStmt = putHelper(-2);
    parseStmt  += "public void parseValue(String attValue){\n";
    parseStmt  += putHelper(1);
    parseStmt  += gens;
    parseStmt  += putHelper(0);
    parseStmt  += "value(t_"+String.valueOf(tempcnt-1)+");\n";
    parseStmt  += putHelper(-1);
    parseStmt  += "}\n";

    parseStmt  += putHelper(0);
    String toStrStmt = "public String toString()\n {\n    String tempVal = String.valueOf(value());\n    return tempVal;\n }\n";
    parseStmt  += toStrStmt;

    System.out.println(repositoryID+" has parse methods:"+parseStmt);
    return parseStmt;
  }

public static String sequenceType(IDLType type_def)
  {
    SequenceDef sdef = SequenceDefHelper.narrow(type_def);
    int kindVal = sdef.element_type().kind().value();
    String s = typeStr(kindVal);
    s = "sequence&lt;"+s+"&gt;";
    return s;
  }

public static String insertNonSimple(IDLType idltype, String type, 
			    String repositoryID , String attname, 
		         int tval, String stname,  boolean isXml,
			String[] parseStmt)
  {
    String innerStag=null;
    if (tval == org.omg.CORBA.TCKind._tk_sequence){
       innerStag = "sequence";
       makeSeqStmt(idltype, stname,parseStmt);
    }
    else if (tval == org.omg.CORBA.TCKind._tk_struct){
      innerStag = "struct";
    }
  
    String simpProp="";
    if (isXml){
      ////
      simpProp += putSpace(0);
      simpProp += "<"+innerStag+" type=\""+type+"\" name=\""+attname+"\">\n";
      
      String description = "this is optional desctiption";
      simpProp += putSpace(1);
      simpProp += "<description>"+description+"</description>\n";
    
      simpProp += putSpace(0);
      simpProp += "<repositoryID>"+repositoryID+"</repositoryID>\n";
    }

    //If I am struct, insert members here..
    if (tval == org.omg.CORBA.TCKind._tk_struct){

      //add new struct() stmt
      try{
         String sttype = getType(idltype.type().id());
         String newStmt = stname+" = new "+sttype+"();\n";
	 parseStmt[0] += putHelper(0);
         parseStmt[0] += newStmt;
      }catch(org.omg.CORBA.TypeCodePackage.BadKind e){}  

      simpProp += buildStructMembers(idltype, stname,isXml,parseStmt,false);
    }

    if (isXml){
      simpProp += putSpace(-1);
      simpProp += "</"+innerStag+"> \n";
    }
    return simpProp;
  }

public static String  findSeqeunceDim(IDLType itype, int[] typeval, 
 				IDLType []btype)
  {
    org.omg.CORBA.TypeCode tcode = itype.type();
    int tval = tcode.kind().value();
    //System.out.println("kindVal in findSeqeunceDim:"+tval);
    if (tval ==  org.omg.CORBA.TCKind._tk_alias){
      //System.out.println("kindVal in findSeqeunceDim:Alis");
      AliasDef adef = AliasDefHelper.narrow(itype);
      itype = adef.original_type_def();
      String upper = findSeqeunceDim(itype,typeval,btype);
      return upper;
    }
    else if (tval ==  org.omg.CORBA.TCKind._tk_sequence){
      //System.out.println("kindVal in findSeqeunceDim:sequence");
      SequenceDef adef = SequenceDefHelper.narrow(itype);
      String upper= findSeqeunceDim(adef.element_type_def(),typeval,btype);
      return (upper+"[]");
    }
    //System.out.println("kindVal in findSeqeunceDim:basic");
    String basicType= null;
    if (isSimple(tval) && (tval != org.omg.CORBA.TCKind._tk_objref)){
      basicType = typeStr(tval);
      typeval[0] = tval;
    }
    else {
      try{
	basicType = tcode.id();
        typeval[0] = tval;
      }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){
	System.out.println("kindVal in findSeqeunceDim:Ex:"+ex+"kind:"+tval);
      }
    }
    btype[0] = itype;
    return basicType;
  }

  public static String buildNonSimpleAttr(InterfaceDef wrapper_idef,
					  AttributeDef attrVal_def,
					  AttributeDescription attrVal_desc,
					  String attname,String usageName,
					  String eventID)
  {
    String[] parseStmt ={""};
    nextdim = 0;   
    int  kindVal = attrVal_def.type().kind().value();
    int tval = 0;
    String stagName="";
    String innerStag="";
    String elemType=null;
    IDLType idltype=null;
    
    if (kindVal == org.omg.CORBA.TCKind._tk_alias){
      idltype = findTypeFromAlias( attrVal_def);
      tval = findTypeValFromAlias(idltype);
    }
    else{
      tval = kindVal;
      idltype = attrVal_def.type_def();
    }
    String type = typeStr(tval);//kindVal);
    
    String seqMethod = "";
    if (tval == org.omg.CORBA.TCKind._tk_sequence){
      int []typeval = new int[1];
      IDLType []btype = new IDLType[1];
      elemType = findSeqeunceDim(idltype,typeval,btype);
      System.out.println("Seqeunce :elemType"+elemType);
      
      stagName = "sequenceDef";
      innerStag = "sequence";
      type = sequenceType(idltype);
      makeSeqParseValue(idltype, parseStmt);
    }
    else if (tval == org.omg.CORBA.TCKind._tk_struct){
      stagName = "structDef";
      innerStag = "struct";
      makeStructParseValue(idltype, parseStmt);
    }
      

     //start building start tag
    String attID   = usageName; //for now att name and ID are same
    String stag = putSpace(1);
    stag     += "<"+stagName+" attID=\""+attID+"\" eventType=\""+eventID+"\">\n";
    String simpProp = stag;

    String wrapper_interface = wrapper_idef.id(); //wrapper_att.id;
    simpProp += putSpace(1);
    simpProp +="<wrapper_interface>"+wrapper_interface+"</wrapper_interface>\n";
    String repositoryID =null;
    try{
      repositoryID = attrVal_def.type().id();//simpleAtt.id;
      repositoryID = idltype.type().id();
    }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){
      try{
	repositoryID = attrVal_def.type().id();//simpleAtt.id;
      }catch(org.omg.CORBA.TypeCodePackage.BadKind e){}
      System.out.println("buildSimpleAttr:Ex:"+ex);
    }
   
    ////
    kindVal = attrVal_desc.type.kind().value();
    simpProp += insertNonSimple(idltype,type, repositoryID , attname,
				tval,"newValue",true, parseStmt);
    /////

    simpProp += putSpace(-1);
    simpProp += "</"+stagName+">\n";
    //System.out.println("I got a simple attribute :\n"+simpProp);
    putSpace(-1);


    //now generate wrapper files to extract an dinsert the attribute values
    String transform =  generateAttrWrapper(wrapper_interface, 
					    repositoryID,elemType);

    transform += parseStmt[0];//irtraverse.parseStmt; //seqMethod;
    transform += putHelper(-1);
    transform += "}\n"; 
    transform += putHelper(-1);
    transform += "}";
    String wrapperClassName = getWrapperClassName(wrapper_interface);
    String wrapperClass = wrapperClassName+"Impl";
    writeXMLDoc("attrs/"+wrapperClass+".java", transform);

    return simpProp;
  }

 
  public static String buildStartTagOfModule(InterfaceDef idef)
  {
    String componentID   = getConst("moduleName", idef);
    String startTag = putSpace(1)+"<UserModule idlFile=\""+next_idlFile+"\"";
    startTag += " componentID=\""+componentID+"\""+">\n";

    System.out.println("StartTag :"+startTag);
    return startTag;
  }

 
  public static String putSpace(int num)
  {
    numSpaces += 2*num;
    String buf="";
    for(int k=0;k<numSpaces;k++)
      buf += " ";//" ";
    return buf;

  }
 
   public static String putHelper(int num)
  {
    numHelper += 2*num;
    if (num == -2)
      numHelper = 2;
    System.out.println("num:"+num+" got :"+numHelper);

    String buf="";
    for(int k=0;k<numHelper;k++)
      buf += " ";
    return buf;
  }

  public static boolean isSimple(int kindVal)
  {  
    if ( ((kindVal>=org.omg.CORBA.TCKind._tk_void)&&
	    (kindVal<=org.omg.CORBA.TCKind._tk_octet))||
	   (kindVal == org.omg.CORBA.TCKind._tk_string)||
	   (kindVal == org.omg.CORBA.TCKind._tk_objref))
      return true;
    return false;
  }

public static String getParType(org.omg.CORBA.TypeCode tcode)
  {
    String type=null;
    try{
      int kindVal = tcode.kind().value();
      if ((isSimple(kindVal))&&
	  (!(kindVal == org.omg.CORBA.TCKind._tk_objref)))
	type = typeStr(kindVal);
      else 
	type = tcode.id();
    }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){}
    return type;
    
  }

 public static String insertMethodDescs(InterfaceDef idef)
  {
    String simpProp="";

    FullInterfaceDescription fides = idef.describe_interface();
    OperationDescription []opdesc  = fides.operations;
    if (opdesc.length == 0)
      return simpProp;

    simpProp += putSpace(0);
    simpProp += "<methodList>\n";
   
    if(opdesc.length > 0)
      putSpace(1);
    for(int k=0;k<opdesc.length;k++){
      OperationDescription nextop = opdesc[k];
      String opname = nextop.name;
      String returnType = getParType(nextop.result);

      simpProp += putSpace(0);
      simpProp +="<method name=\""+opname+"\" returnType=\""+
	                           returnType+"\">\n";
      ParameterDescription []pardesc = nextop.parameters;
     
      if (pardesc.length >0)
	putSpace(1);

      for(int j=0;j<pardesc.length;j++){
	ParameterDescription nextpar = pardesc[j];
	String parname = nextpar.name;
	String parType = getParType(nextpar.type);
	String onepar  = "<parameter name=\""+parname+
	                    "\" type=\""+parType+"\"/>\n";

	simpProp += putSpace(0);
	simpProp += onepar;
      }
      if (pardesc.length >0)
	putSpace(-1);
      simpProp += putSpace(0);
      simpProp +="</method>\n";
    }
    if (opdesc.length >0)
      putSpace(-1);
    simpProp += putSpace(0);
    simpProp += "</methodList>\n";
    return simpProp;
  }

  public static String processUserModule(Contained achild)
  {

 
    String xml="";
    InterfaceDef wrapper_idef=null;
    org.omg.CORBA.Contained contained=null;

    InterfaceDef idef=org.omg.CORBA.InterfaceDefHelper.narrow(achild);
    FullInterfaceDescription fullIntDesc = idef.describe_interface();  

    xml += buildStartTagOfModule(idef);
    String repositoryID = fullIntDesc.id;
    xml += putSpace(1);
    xml += "<repositoryID>"+repositoryID + "</repositoryID>\n";
   
    AttributeDescription []atts = fullIntDesc.attributes;
    if (atts.length >0){
       xml += putSpace(0);
       xml += "<properties>\n";
    }

    for(int k=0;k<atts.length;k++){ 
      AttributeDescription wrapper_att = atts[k];
      int wrapper_kind = wrapper_att.type.kind().value();
      if (wrapper_kind !=  org.omg.CORBA.TCKind._tk_objref){
	System.out.println("attribute is not CORRECT kind:"+wrapper_kind);
	continue;
      }

      //findwrapper interface for this attribute
      try{
	contained = repository.lookup_id(wrapper_att.type.id());
      }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){
      System.out.println("I GOT EXC:"+ex);};

      wrapper_idef  = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
      String baseID = baseInterface(wrapper_idef);
      String eventID="null";
      //System.out.println("This  is  :"+baseID+" attribute");
      if (whichAttribute(wrapper_idef, "VetoableChangeEvent"))
	baseID = "vetoableEvent";
      else if(whichAttribute(wrapper_idef,"PropertyChangeEvent"))
	baseID = "propertyEvent";
      else if (whichAttribute(wrapper_idef,"GenericEvent"))
	baseID = "genericEvent";
      else{
	  System.out.println("attribute base is not correct");
	  continue;
      }
      
      String attrName  = wrapper_att.name;
      String usageName = getConst("eventName", wrapper_idef);
      System.out.println("The usage name of attribute :"+usageName+
			 " id:"+wrapper_idef.id());

      //AttributeDescription att_desc = getTypeOfAttr(wrapper_idef);
      contained = wrapper_idef.lookup("value");
      AttributeDef  attrVal_def  = AttributeDefHelper.narrow(contained);
      AttributeDescription attrVal_desc = getTypeOfAttr(contained);
      System.out.println("I got the attribute ID in wrapper:");
      
      //If the attribute is simple (long, float,...)
      int kindVal = attrVal_desc.type.kind().value();
      System.out.println("I got the kindVal:"+kindVal);
      if (isSimple(kindVal)){
	//process this simple attribute
	xml += buildSimpleAttr(wrapper_idef,attrVal_def,attrVal_desc, 
			       attrName,usageName, baseID);
      }
      else if ((kindVal == org.omg.CORBA.TCKind._tk_alias)||
	       (kindVal == org.omg.CORBA.TCKind._tk_struct))
	{
	  xml +=buildNonSimpleAttr(wrapper_idef, attrVal_def,attrVal_desc, 
				   attrName,usageName,baseID);
	}
      //System.out.println("Current props :"+xml);
    }
   
    //putSpace(-1);
    if (atts.length >0){
      xml += putSpace(0);
      xml += "</properties>\n";
    }
    //put method descriptions if any
    xml += insertMethodDescs(idef);

    putSpace(-1);
    xml += putSpace(0);
    xml += "</UserModule>\n"; 
   
    System.out.println("One Simple Type:\n"+xml);
    return xml;
  }

   public static AttributeDescription getTypeOfAttr(Contained contained)
  {
    //first get tha name of usage name
    //find Container
    Description adesc = contained.describe();
    Any aval = adesc.value;
    AttributeDescription att_desc=AttributeDescriptionHelper.extract(aval);
    return att_desc;
  }

   
  public static String getConst(String fieldName, InterfaceDef att_idef)
  {
	//first get tha name of usage name
	//find Container
	Contained contained = att_idef.lookup(fieldName);
	ConstantDef cdef=org.omg.CORBA.ConstantDefHelper.narrow(contained);
	Description adesc = cdef.describe();
	Any aval = adesc.value;
	ConstantDescription cons_desc=ConstantDescriptionHelper.extract(aval);
	String name = cons_desc.value.extract_string();
	return name;
  }

  public static boolean isUserModule(Contained achild)
  {
    FullInterfaceDescription  fullInterfaceDesc,my_idefDesc;

    int desc_val = childKind(achild);
    if (desc_val != org.omg.CORBA.DefinitionKind._dk_Interface)
      return false;
    
    InterfaceDef att_idef=org.omg.CORBA.InterfaceDefHelper.narrow(achild);
    my_idefDesc = att_idef.describe_interface();
    String my_id =  my_idefDesc.id;

    //BeanContext and WebFlowContext inherit BeanContextChild...
    if ((my_id.indexOf("BeanContext") >=0)||
	(my_id.indexOf("WebFlowContext") >=0))
      return false;

    InterfaceDef []base_idefs = att_idef.base_interfaces();
    for(int k=0;k<base_idefs.length;k++){
      InterfaceDef next_idef = base_idefs[k];
      fullInterfaceDesc = next_idef.describe_interface();
      String next_id = fullInterfaceDesc.id;
      if (next_id.indexOf("BeanContextChild") >= 0)
		return true;
	  }
      return false;
  }

public static int  childKind(Contained achild)
  {
    org.omg.CORBA.ContainedPackage.Description desc = achild.describe();
    org.omg.CORBA.DefinitionKind kind = desc.kind;
    int desc_val = kind.value();
    return desc_val;
  }

 public static boolean isContainer(Contained achild)
  {
    int desc_val = childKind(achild);
    if (desc_val == org.omg.CORBA.DefinitionKind._dk_Module)
      return true;
    else
      return false;
  }

public static void writeXMLDoc(String refFile, String xmlStr)
{
  //test
  //System.out.println("Writing to :"+refFile+"\n this:\n"+xmlStr);
  //test

  try
    {
      FileOutputStream file = new FileOutputStream(refFile);
      PrintWriter out = new PrintWriter(file);
      out.println(xmlStr);
      out.flush();
      file.close();
    }
  catch(IOException ex)
    {
      System.err.println("Can't write to `" +  ex.getMessage() + "'");
      System.exit(1);
    }
}

 public static String  traverse(Container container)
  {
    String repID,name;
    System.out.println("traverse:recurse..");
    Contained []childs =  container.contents(
				      org.omg.CORBA.DefinitionKind.dk_all,
				      false);
    String xmldoc="";
    for(int k=0;k<childs.length;k++){
      Contained achild = childs[k];
      repID = achild.id();
      name  = achild.name();
      //System.out.println(" name:"+name+ " repID:"+repID);
      if (isUserModule(achild) ){
	System.out.println("I Got UserModule ...");
	xmldoc += processUserModule(achild);
      }
      //if this child is a container traverse its children recursively
      else if (isContainer(achild))
	xmldoc += traverse(ContainerHelper.narrow(achild));
    }
    return xmldoc;
  }

  public static String getPackageName(String wrapper)
  {
    int firstColon = wrapper.indexOf(":");
    int lastColon = wrapper.lastIndexOf("/");
    String sub = wrapper.substring(firstColon+1, lastColon);
    String packageName = sub.replace('/', '.');
    System.out.println("package name:"+packageName);
    return packageName;
    
  }

   public static String getWrapperClassName(String wrapper)
  {
    int first = wrapper.lastIndexOf("/");
    int last = wrapper.lastIndexOf(":");
    String sub = wrapper.substring(first+1, last);
    String className = sub;
    System.out.println("WrapperClass Name :"+className);
    return className;
    
  }

  public static String javaTypeStr (String idlType)
  {
    System.out.println("Incoming idlType in javaTypeStr:"+idlType);
    String suffix="";
    int pindex = idlType.indexOf("[");
    if (pindex >= 0 )
     {
       suffix = idlType.substring(pindex);
       idlType = idlType.substring(0,pindex);
     }
   
    List idlList = Arrays.asList(idlTable);
    int index = idlList.indexOf(idlType);
    String javaType=null;
    if (index >= 0) 
      javaType = javaTable[index];
    else
      javaType = getFullPackName(idlType);
    
    javaType = javaType+suffix;
    System.out.println("javaType :"+javaType);
    return javaType;
  }

  public static String getFullPackName(String repID)
  {
    int firstColon = repID.indexOf(":");
    int lastColon = repID.lastIndexOf(":");
    String sub = repID.substring(firstColon+1, lastColon);
    String packname = sub.replace('/', '.');
    System.out.println("repId:"+repID+" pack:"+packname);
    return packname;
  }

  //mode :insert or extract
  public static String helperStmt(String variable,String idlType,
				  String eventType, String mode)
  {
    String stmt=null;
    List idlList = Arrays.asList(idlTable);
    int index = idlList.indexOf(idlType);
    if (index >= 0) {
      String helperMethod = mode+"_"+ idlType;
      if (mode.equals("insert"))
        stmt = "any_"+variable+"."+helperMethod+"("+variable+");";
      else
        stmt = variable+" = "+"any_"+variable+"."+helperMethod+"();";
    }
    else{
      if (mode.equals("insert"))
        stmt = eventType+"Helper."+mode+"(any_"+variable+", "+variable+");";
      else
        stmt = variable+" = "+eventType+"Helper."+mode+"(any_"+variable+");";
    }
    return stmt;
  }
     
  public static String replaceItem(String buf, String what , String with)
  {
    int counter=0;
    int len = what.length();
    for(int index = buf.indexOf(what,counter);index>=0;){
      buf = buf.substring(0,index)+with+buf.substring(index+len);
      counter = ++index;
      index = buf.indexOf(what,counter);
    }
    return buf;
  }

  public static String  generateAttrWrapper(String wrapper, 
				   String repositoryID, String elemType)
  {
       
    String packageName = getPackageName(wrapper);
    String wrapperClassName = getWrapperClassName(wrapper);
    String implBase = "_"+wrapperClassName+"ImplBase";
    String wrapperClass = wrapperClassName+"Impl";
    String eventType = javaTypeStr(repositoryID);
   
    String excludeDim = eventType;
    if (elemType != null ){
      repositoryID = getFullPackName(repositoryID);
      eventType = javaTypeStr(elemType);
    }

    String old_val_stmt =  helperStmt("oldValue",repositoryID, 
				      excludeDim,"insert");
    String new_val_stmt =  helperStmt("newValue",repositoryID, 
				      excludeDim,"insert");
    String transform = template;
    transform = replaceItem(transform,"PACKAGE",packageName);
    transform = replaceItem(transform,"WRAPPER_CLASS",  wrapperClass);
    transform =  replaceItem(transform,"IMPL_CLASS",implBase);
    transform =  replaceItem(transform,"EVT_TYPE",eventType);
    transform =  replaceItem(transform,"OLD_VAL_TRANSFORM", old_val_stmt );
    transform =  replaceItem(transform,"NEW_VAL_TRANSFORM",new_val_stmt );
    new_val_stmt =  helperStmt("newValue",repositoryID, 
				      excludeDim,"extract");
    transform =  replaceItem(transform,"NEW_EXTRACT",new_val_stmt );
    old_val_stmt =  helperStmt("oldValue",repositoryID, 
				      excludeDim,"extract");
    transform =  replaceItem(transform,"OLD_EXTRACT",old_val_stmt );
    //write into a file
    //System.out.println("Transformed stmt:"+transform);
    //writeXMLDoc("attrs/"+wrapperClass+".java", transform);
    return transform;
  }
   

static String template="package PACKAGE ;\n\n//\n//Wrapper class for user attributes,generated automatically\n//\npublic class WRAPPER_CLASS extends IMPL_CLASS\n{\n  //extract EVT_TYPE from its IR id\n  EVT_TYPE oldValue,newValue;\n  org.omg.CORBA.Any  any_oldValue,any_newValue;\n  org.omg.CORBA.Object evtSource;\n  String propertyName;\n  String args[] = {\" \"};\n  org.omg.CORBA.ORB orb =  org.omg.CORBA.ORB.init(args, new java.util.Properties()); \n\n  public  WRAPPER_CLASS ()\n  {\n       this.oldValue = null;\n       this.newValue = null;\n       propertyName = eventName;\n       this.any_oldValue  = orb.create_any();\n       this.any_newValue =  orb.create_any();\n   }\n\n public  WRAPPER_CLASS  (EVT_TYPE oldValue, EVT_TYPE newVal)\n  {\n    this.oldValue = oldValue;\n    this.newValue = newVal;\n    propertyName = eventName;\n    any_oldValue = orb.create_any();\n    any_oldValue= orb.create_any();\n    //transform the attribute into the type of Any\n    OLD_VAL_TRANSFORM\n    //transform the attribute into the type of Any\n    NEW_VAL_TRANSFORM\n  }\n\n  public  WRAPPER_CLASS (EVT_TYPE newValue)\n  {\n     this.oldValue = null;    \nthis.newValue = newValue;\n     propertyName = eventName;\n     any_oldValue= orb.create_any();\n     any_newValue= orb.create_any();\n     //transform the attribute into the type of Any\n     NEW_VAL_TRANSFORM\n   } \npublic  WRAPPER_CLASS (org.omg.CORBA.Any  any_newValue)\n {\n       //newValue = any_newValue.extract_string() or WebFlow.test.type.extract(any_newValue) \n        NEW_EXTRACT\n       this.oldValue = null;\n       propertyName = eventName;\n       this.any_oldValue  = orb.create_any();\n       this.any_newValue =  any_newValue;\n   } \npublic org.omg.CORBA.Object getSource(){\n    return evtSource;\n  }\n\n public void  setSource(org.omg.CORBA.Object source_){\n     this.evtSource = source_;\n  }\n\n  public String getPropertyName() {\n    return propertyName;\n  }\n\n  public org.omg.CORBA.Any getNewValue() {\n    return any_newValue;\n  }\n\n  public org.omg.CORBA.Any getOldValue() {\n    return any_oldValue;\n  } \n \n  public void  setNewValue(org.omg.CORBA.Any any_newValue) {\n       NEW_EXTRACT\n       this.oldValue = null;\n       this.newValue = newValue;\n       propertyName = eventName;\n       this.any_oldValue  = orb.create_any();\n       this.any_newValue =  any_newValue;\n  }\n\n  public void setOldValue(org.omg.CORBA.Any any_oldValue) {\n    OLD_EXTRACT\n    this.newValue = null;\n    this.oldValue = oldValue;\n    propertyName = eventName;\n    this.any_newValue  = orb.create_any();\n    this.any_oldValue =  any_oldValue;\n  } \n\npublic  EVT_TYPE value() {\n    return newValue;\n  }\n\n  public void value(EVT_TYPE newValue) {\n    //transform the attribute into the type of Any\n    NEW_VAL_TRANSFORM\n    this.newValue = newValue;\n  }\n\n";
  
}

  


