package WebFlow.util;

import WebFlow.event.*;
import WebFlow.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import org.omg.CORBA.*;
import java.net.*;
import WebFlow.xml.*;
import org.w3c.dom.*;
import java.sql.*;

public class install {

   public static Document  root;
   public static org.omg.CORBA.Object server;
   public static Hashtable moduleTable;
   public static org.omg.CORBA.ORB orb;
  public static org.omg.CORBA.Object []ms = new org.omg.CORBA.Object[30];
  public static int cnt=0;
   public static Connection jdbc_conn;
   public static configReaderImpl creader;

   public static void  main (String []args)
   {
     int argslen = args.length;
     if (argslen == 2){
       if (args[0].indexOf("http://") < 0){
	 System.out.println("install  masterurl xmlFileName");
	 return;
       }
     }
     else if (argslen == 1){
       if (args[0].indexOf("http://") < 0){
	 System.out.println("install masterurl");
	 return;
       }
     }
     orb = ORB.init(args, new java.util.Properties());
     String masterURL = args[0];
     String masterRef = waitForMaster(masterURL);
     org.omg.CORBA.Object server = orb.string_to_object(masterRef);
     creader = new configReaderImpl(orb);


     //install from XML document
     if (argslen == 2){
       String xmlfileName = args[1];
       install installer = new install(server, xmlfileName);
       installer.makeInstall();
     }
     // install from DataBase
     else if (argslen == 1){
       makeInstallFromDataBase(server);
     }

     waitForInput();
   }

   public static String  waitForMaster(String masterURL)
   {
     String ref=null;
     org.omg.CORBA.Object obj=null;
     boolean flag=true;
     while(flag){
       ref = getIORFromURL(masterURL);
       System.out.println("Got ior :"+ref);
       obj = orb.string_to_object(ref);
       boolean non_exist = true;
       try{
	 non_exist = obj._non_existent();
       }catch(org.omg.CORBA.COMM_FAILURE ex){}
        catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
       
       if (!non_exist)
	 flag = false;
       try{
	 Thread.sleep(500);
       }catch(InterruptedException ex){
       }
     }
     System.out.println("waitForMaster after while loop..");
     return ref;
  }

   public install (org.omg.CORBA.Object server, String xmlFileName)
   {

     this.server = server;
     moduleTable  = new Hashtable();

     Document document=null;
     try{
        DOMParser parser = new DOMParser();
        root = parser.parse(xmlFileName);
     }catch (Exception e) {
        e.printStackTrace(System.err);
        return;
     }

     //store the IOR of WebFlow server in DOM tree
     NodeList elements = root.getElementsByTagName("WebFlowContext");
     Element outerContext = (Element)elements.item(0);

     //ORB:transform to IOR
     String contextIOR = orb.object_to_string(server);
     //String contextIOR ="";
     ms[cnt++] =  server;
     outerContext.setAttribute("ior", contextIOR);
    
   }

   
   public static void makeInstallFromDataBase(
					org.omg.CORBA.Object masterServer)
   {
     jdbc_conn = creader.connectToDataBase("akarsu","akarsu");
     Statement stmt = null;
      //first get connection table
     try{
       stmt = jdbc_conn.createStatement();

       // connections table
       // sourceID , targetID ,eventID , targetMethod, typeOfConnection
       // ========   ========  =======   ============  ================

       String request = "select * from connections_table";
       ResultSet results = stmt.executeQuery(request);
       ResultSetMetaData rsmd = results.getMetaData(); 
       int numColumns = rsmd.getColumnCount();
     

       Hashtable connections_list = new Hashtable();
       while(results.next()){
	 String []row = new String[numColumns];
	 for(int k=0;k<numColumns;k++){
	   row[k] = results.getString(k+1);
	   row[k] = row[k].trim();
	 }
	 String objectID = row[0];
	 Vector ce = (Vector)connections_list.get(objectID);
	 if (ce == null){
	   ce = new Vector();
	   connections_list.put(objectID, ce);
	 }
	 ce.add(row);
       }
       stmt.close();

       //Second get attributes table
       //attributes table
       //objectID , attID ,attName , wrapperID, binary_value, xml_value 
       //========   =====  =======   =========  ============  ========= 
       //now set attributes if any
       stmt = jdbc_conn.createStatement();
       request = "select * from attributes_table";
       results = stmt.executeQuery(request);
       rsmd = results.getMetaData(); 
       numColumns = rsmd.getColumnCount();
       
       Hashtable attributes_list = new Hashtable();
       while(results.next()){
	 String []row = new String[numColumns];
	 for(int k=0;k<numColumns;k++){
	   row[k] = results.getString(k+1);
	   row[k] = row[k].trim();
	 }
	 String objectID = row[0];
	 Vector ce = (Vector)attributes_list.get(objectID);
	 if (ce == null){
	   ce = new Vector();
	   attributes_list.put(objectID, ce);
	 }
	 ce.add(row);
       }
       stmt.close();
       
       //third install objects
       stmt = jdbc_conn.createStatement();

       //Second get objecs table
       //objects  table
       //OID ,      parentID ,ObjecttIOR isModule
       //========   =====     =======    =========
       /////////////////////////////
       request = "select * from objects_table";
       results = stmt.executeQuery(request);
       rsmd = results.getMetaData(); 
       numColumns = rsmd.getColumnCount();
       

       //first read all objects and put them into a list and sort it
       Hashtable object_hash_list = new Hashtable();
       while(results.next()){
	 String []row = new String[numColumns];
	 for(int k=0;k<numColumns;k++){
	   row[k] = results.getString(k+1);
	   row[k] = row[k].trim();
	   System.out.print(row[k]+",");
	 }
	 String objectID = row[0];
	 object_hash_list.put(objectID, row);
       }
       //sort it
       java.lang.Object[] objects_list =  sortObjectList(object_hash_list);


       org.omg.CORBA.Object obj = null;
       comparator comp = new comparator();
       int size = objects_list.length;
       for(int k=0;k<size;k++){
      	 String []row = (String[])objects_list[k];
	 String objectID = row[0];
	 Vector attList = (Vector)attributes_list.get(objectID);
	 String parentID = row[1];

	 String []keyArray = new String[1];
	 keyArray[0] = parentID;
	 int parentIndex = Arrays.binarySearch(objects_list,keyArray,comp);
	 System.out.println("makeInstallFromDataBase:pind:"+parentIndex);

	 if (parentIndex < 0){
	   System.out.println("makeInstallFromDataBase:continue:..");
	   row[2] = orb.object_to_string(masterServer);
	   objects_list[k] = row;
	   continue;
	 }
	 String []myParent = (String [])objects_list[parentIndex];

	 //If object is module
	 if (row[numColumns-1].equals("M"))
	   obj = installModuleFromJDBC(row,attList,myParent);
	 else if (row[numColumns-1].equals("C"))
	   obj = installContextFromJDBC(row,attList,myParent);
	 else
	   System.out.println("makeInstallFromDataBase: unknown indicator"+
			      row[numColumns-1]);

	 row[2] = orb.object_to_string(obj);
	 objects_list[k] = row;
       }
       
       Hashtable newObjList = toHashTable(objects_list);
       //forth make connection among objects
       makeConnectionsFromDataBase(connections_list, newObjList);

       stmt.close();
     }catch(SQLException ex){
       System.out.println("There is problem in makeInstallFromDataBase:"+ex);
     }
     
   }


  public static Hashtable toHashTable(java.lang.Object []list)
  {
    Hashtable table = new Hashtable();
    int size = list.length;
    for(int k=0;k<size;k++){
       String[] item = (String[])list[k];
       String objectID = item[0];
       table.put(objectID, item);
    }
    return table;
  }


  public  static java.lang.Object []sortObjectList(Hashtable objects_list)
  {
    java.lang.Object []raw_list = objects_list.values().toArray();
    Arrays.sort(raw_list, new comparator());

    System.out.println("OID-parentID---");
    for(int k=0;k<raw_list.length;k++){
      String[] item = (String[])raw_list[k];
      System.out.println(item[0]+"    -     "+item[1]);
    }


    return raw_list;
  }

 

    public static org.omg.CORBA.Object installModuleFromJDBC(String []mentry,
			       Vector attList,String []myParent)
    {
      System.out.println("installModuleFromJDBC is called..:"+attList);

     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj =  orb.string_to_object(myParent[2]);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     
     //add new module
     String objectID = mentry[0];
     org.omg.CORBA.Object new_module=null;
     String compRef = objectID.substring(objectID.lastIndexOf("/")+1);
     new_module = parentContext.addNewModule(compRef);
     String new_moduleIOR = orb.object_to_string(new_module);
     System.out.println("installModuleFromJDBC:after create module..");

     try{
       //update my entry to reflect my IOR
       Statement stmt = jdbc_conn.createStatement();
       String request = "UPDATE objects_table  SET objectIOR=\'"+
	 new_moduleIOR+"\' where OID=\'"+objectID+"\'";
       ResultSet results = stmt.executeQuery(request);
     }catch(SQLException ex){
       System.out.println("There is problem in installModuleFromJDBC:"+ex);
     }  
     //return instantiated object
     if (attList == null)
       return new_module; 

     
     System.out.println("installModuleFromJDBC:before get atts.:"+attList);
     //attributes table
     //objectID , attID ,attName , wrapperID, binary_value, xml_value 
     //========   =====  =======   =========  ============  ========= 
     //now set attributes if any
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_module);
     for(int k=0;k<attList.size();k++){
       String []arow   = (String[])attList.elementAt(k);
       String attName   = arow[2]; //attName field 
       String wrapperID = arow[3]; //wrapperID field;
       String binaryVal  = arow[4]; //binary_value field
       System.out.println("installModuleFromJDBC:after get atts.");
       org.omg.CORBA.Any propVal=creader.propertyInAny(binaryVal);
       creader.setModuleAnyAttribute(propVal,bcc,attName,wrapperID);
       System.out.println("installModuleFromJDBC:after installed atts.");
     }
     System.out.println("installModuleFromJDBC:after for loop..");
     
     //return instantiated object
     return new_module;
   }
 
    public static org.omg.CORBA.Object installContextFromJDBC(String []mentry,
			       Vector attList,String[] myParent)
   {

     System.out.println("installContextFromJDBC is called..");
     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj =  orb.string_to_object(myParent[2]);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     
     //add new context
     String objectID = mentry[0];
     org.omg.CORBA.Object new_context=null;
     try{
       new_context = parentContext.addNewContext(objectID);
     }catch(PropertyVetoException e){
       System.out.println("Install context:"+e);System.exit(0);}
     catch(WebFlow.NullPointerException e){
       System.out.println("Install context:"+e);System.exit(0);}
     String new_contextIOR = orb.object_to_string(new_context);

     try{
       //update my entry to reflect my IOR
       Statement stmt = jdbc_conn.createStatement();
       String request = "UPDATE objects_table  SET objectIOR=\'"+
                       new_contextIOR+"\' where OID=\'"+objectID+"\'";
       ResultSet results = stmt.executeQuery(request);
     }catch(SQLException ex){
       System.out.println("There is problem in installContextFromJDBC:"+ex);
     } 
     
     //return new context object
     return new_context;
   }

   public static void makeConnectionsFromDataBase(Hashtable connections_list, 
					     Hashtable objects_list)
   {
     org.omg.CORBA.Object sourceObj,targetObj;
     //Objects-table
     // OID , parentID , objectIOR
     // ===   ========   =========
     for(Enumeration e=objects_list.elements();e.hasMoreElements();){
       System.out.println("makeCon:begon for loop");

       String []orow = (String[])e.nextElement();
       String objectID = orow[0];
       sourceObj = orb.string_to_object(orow[2]);
       System.out.println("makeCon:begon for loop for:"+objectID);

       String parentID = orow[1];
       String []pelem = (String[])objects_list.get(parentID);
       //if my parent ios null, that I am root, then continue
       if (pelem == null)
	 continue;

       String parentIOR = pelem[2];
       org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
       WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);


       // connections table
       // sourceID , targetID ,eventID , targetMethod, typeOfConnection
       // ========   ========  =======   ============  ================

       Vector ce = (Vector)connections_list.get(objectID);
       if (ce == null)
	 continue;

       for(int k=0;k<ce.size();k++){
	 String []crow = (String[])ce.elementAt(k);
     
	 String targetID = crow[1];
	 pelem = (String[])objects_list.get(targetID);
	 targetObj = orb.string_to_object(pelem[2]);
	 String eventRef  = crow[2];
	 String targetMethod = crow[3];
	 String connectMode = crow[4];
	 System.out.println("Establish this conne:targetID:"+targetID+
		     " connectMode:"+connectMode+" eventRef:"+eventRef+
			    " targetMethod:"+targetMethod);
 
	 if (connectMode.equals("push"))
	   parentContext.attachPushEvent(sourceObj,eventRef,
					 targetObj,targetMethod);
	 else if (connectMode.equals("pull"))
	   parentContext.attachPullEvent(sourceObj,eventRef,
					 targetObj);
       }
     }
   }


   public static  void makeInstall()
   {
     makeInstall_ex(root);
     makeConnection();
   }

   public static void makeInstall_ex(Node root)
   {
       NodeList list = root.getChildNodes();
       for(int k=0;k<list.getLength();k++){
	 Node node = list.item(k);
         int type = node.getNodeType();
	 if (type != Node.ELEMENT_NODE)
	   continue;
	 Element next = (Element)node;
	 String tag = next.getTagName();
	 if (tag.equals("WebFlowContext")){
	   installContext(next);
	   makeInstall_ex(next);
	 }
	 else if (tag.equals("ModuleInstance"))
	    installModule(next);
	 else
	   makeInstall_ex(node);

       }
   }
  
   public static Element getNode(Element parent, String nodeTag)
   {
     Node next=null;
     for(next=parent.getFirstChild();next!=null;next=next.getNextSibling()){
       Node node = next;
       int type = node.getNodeType();
       if (type != Node.ELEMENT_NODE)
	 continue;
       Element elem = (Element)node;
       if (elem.getTagName().equals(nodeTag))
	 break;
     }
     return (Element)next;
   }

   public static void installContext(Element contextNode)
   {
     Element parent = (Element)contextNode.getParentNode();
     //assume that outermost context, webflow server is ready
     //If context is Webflow server, return
     if (parent.getTagName().equals("distributed_application"))
       return;

     //obtain parent WebFlow context
     String parentIOR = parent.getAttribute("ior");
     //ORB:transform from IOR to real CORBA Object
     org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     

     //create now new context
     String ID = contextNode.getAttribute("componentID");
     System.out.println("Install context:"+ID);
     //ORB:transform to IOR
     org.omg.CORBA.Object new_context=null;
     try{
       new_context = parentContext.addNewContext(ID);
     }catch(PropertyVetoException e){
       System.out.println("Install context:"+e);System.exit(0);}
     catch(WebFlow.NullPointerException e){
       System.out.println("Install context:"+e);System.exit(0);}
     String next_contextIOR = orb.object_to_string(new_context);
     //String next_contextIOR="";

     //set my IOR
     contextNode.setAttribute("ior", next_contextIOR);

     //add it into object list
     System.out.println(cnt+":"+ID);
     ms[cnt++] = new_context;
   }

   public static void installModule(Element moduleNode)
   {
     Element parent = (Element)moduleNode.getParentNode();

     //obtain parent WebFlow context
     String parentIOR = parent.getAttribute("ior");
     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     
     //create now new Module
     //get componentRef Node
     Element compRefNode = getNode(moduleNode, "componentRef");
     String compRef = compRefNode.getFirstChild().getNodeValue();
     Element modeIDNode = getNode(moduleNode, "moduleID");
     String moduleID = modeIDNode.getFirstChild().getNodeValue();
     System.out.println("installModule:compRef:"+compRef+" modeID:"+moduleID);

      //ORB:transform to IOR
     org.omg.CORBA.Object new_module=null;
     new_module = parentContext.addNewModule(compRef);
     String next_moduleIOR = orb.object_to_string(new_module);
     //org.omg.CORBA.Object new_module = null;
     //String next_moduleIOR ="";

     //add it into object list
     System.out.println(cnt+":"+moduleID);
     ms[cnt++] = new_module;
     
     //set my IOR
     moduleNode.setAttribute("ior", next_moduleIOR);
     //add new instantiated module into table for connecting events
     //ORB:put the module reference to table
     moduleTable.put(moduleID, new_module); 
     //moduleTable.put(modeID, "");

     //now set attributes if any
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_module);
     bcc.restoreXMLProperties();
   }

  public static void makeConnection()
   {
     NodeList connections = root.getElementsByTagName("connect");
     for(int k=0;k<connections.getLength();k++)
       {
	 org.omg.CORBA.Object sourceObj,targetObj;
	 
	 Element connect = (Element)connections.item(k);
	 String connectMode =  connect.getAttribute("typeOfConnection");
	 String eventRef =  connect.getAttribute("eventRef");
	 System.out.println("makeConnection:connectMode:"+connectMode+
			    " eventRef:"+eventRef);

	 Element parent = (Element)connect.getParentNode().getParentNode();
	 //obtain parent WebFlow context
	 String parentIOR = parent.getAttribute("ior");
	 //System.out.println("makeConnection:parentIor:"+parentIOR);
	 //ORB:transform from IOR to CORBA Object
	 org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
	 WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
	
	 //find source
	 Element source = getNode(connect, "sourceObject");
	 Element moduleRefNode = getNode(source, "moduleRef");
	 String  sourceModuleRef = moduleRefNode.getFirstChild().getNodeValue();
	 //ORB:get source reference from table
	 sourceObj = (org.omg.CORBA.Object)moduleTable.get(sourceModuleRef);
	 

	 System.out.println("sourceModuleRef :"+sourceModuleRef);
 
         //find target
	 Element target = getNode(connect, "targetObject");
	 moduleRefNode = getNode(target, "moduleRef");
	 String targetModuleRef = moduleRefNode.getFirstChild().getNodeValue();
	 //ORB:get target reference from table
	 targetObj = (org.omg.CORBA.Object)moduleTable.get(targetModuleRef);
	 System.out.println("targetModuleRef :"+targetModuleRef);

	 //find target method
	 Node targetMethodNode;
	 targetMethodNode = getNode(target, "targetMethod");
	 String targetMethod = targetMethodNode.getFirstChild().getNodeValue();
	 System.out.println("targetMethod :"+targetMethod);

	 //check second parameter of XpushX and XPullX methods?????????
	 //ORB:not the time to make connection
	 if (connectMode.equals("push"))
	   parentContext.attachPushEvent(sourceObj,eventRef,
					 targetObj,targetMethod);
	 else if (connectMode.equals("pull"))
	   parentContext.attachPullEvent(sourceObj,eventRef,
					 targetObj);
       }
   }
 
   
  public static String  getIORFromURL(String url) 
  {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
	try {
	  URL u = new URL(url);
	  // now turn the URL into a DataInputStream
	  try {
	    DataInputStream theHTML = new DataInputStream(u.openStream());
	    try {
	      while ((thisLine = theHTML.readLine()) != null) {
		masterServerIOR += thisLine;
	      } // while loop ends here
	    }  // end try
	    catch (Exception e) {
	      System.out.println("install:getIORfromURL:"+e);
	    }
	  } // end try
	  catch (Exception e) {
	    System.out.println("install:getIORfromURL:"+e);
	  }

	} // end try
	catch (MalformedURLException e) {
	  System.out.println("install:getIORfromURL:"+url + 
			     " is not a parseable URL");
	  System.out.println("install:getIORfromURL:"+e);
	}
	return masterServerIOR;
  }
  

public static void waitForInput()
  {
    String input;
    boolean flag=true;
    try{
    do
      {
	System.out.print(">>>> ");
	DataInputStream dataIn = new DataInputStream(System.in);
	BufferedReader in =
	  new BufferedReader(new InputStreamReader(dataIn));
	input = in.readLine();
	
	if(input.indexOf("d") == 0){
	  //int c = Integet.parseInt(input.substring(1,1));
	  int index_1 = input.indexOf("-");
	  int index_2 = input.lastIndexOf("-");
	  int ci = Integer.parseInt(input.substring(1,index_1));
	  int mi = Integer.parseInt(input.substring(index_1+1,index_2));
	  int mj = Integer.parseInt(input.substring(index_2+1));
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);

	  System.out.println("Client: Detaching property p1-k1");
	  wfc.detachPushEvent(ms[mi],"timeElapsed",ms[mj],"getTime");
	}
	if(input.indexOf("rc") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1));
	  System.out.println("Client: Remove context:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.removeContext(ms[mi]);
	}
	
	if(input.indexOf("rm") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1));
	  System.out.println("Client: Remove child:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.removeModule(ms[mi]);
	}
	if(input.indexOf("cm") == 0){
	  int index = input.indexOf("-");
	  int lindex = input.lastIndexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1,
						    lindex));
	  int mj = Integer.parseInt(input.substring(lindex+1));
	  System.out.println("Client: Remove child:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.copyModuleBinding(ms[mi], ms[mj]);
	}
	if(input.indexOf("ci") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  String name = input.substring(index+1);
	  System.out.println("Client: Change Impl of :"+ci+" with:"+name);
	  BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
	  bcc.changeImpl(name);
	}
	if(input.indexOf("ri") == 0){
	  int ci = Integer.parseInt(input.substring(2));
	  System.out.println("Client: Remoev itself of :"+ci);
	  BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
	  bcc.removeMyself();
	}
	if(input.indexOf("li") == 0){
	  int ci = Integer.parseInt(input.substring(2));
	  System.out.println("Client: List :"+ci);
	  listContents(ms[ci]);
	}
	//xmlb : save as binary... xmla: save as ascii xml file
	if(input.indexOf("xml") == 0){
	  char  cc = input.charAt(3);
	  String saveCase="";
	  if (cc == 'b')
	    saveCase = "binary";
	  else if (cc == 'a')
	    saveCase = "ascii";

	  int ci = Integer.parseInt(input.substring(4));
	  System.out.println("Client: xml :"+ci);
	  WebFlowContext wfc=WebFlowContextHelper.narrow(ms[ci]);
	  if (saveCase.length() > 0){
	    String xmlFragment = wfc.saveStateInXml(saveCase);
	    System.out.println(wfc.getObjectID()+
			     " got this XML Document:"+xmlFragment);
	  }
	  else // save in database through JDBC
	       wfc.saveStateInDataBase();
	}
      }while(flag);
    }catch(IOException e){}
}

static public void listContents(org.omg.CORBA.Object context)
  {
    WebFlowContext wfc = WebFlowContextHelper.narrow(context);
    System.out.println("This Context has the following childs:"+
			wfc.getObjectID());
    org.omg.CORBA.Object []list = wfc.toArray();
     System.out.println("This Context has :"+list.length+" children..");
    for(int k=0;k<list.length;k++){
      BeanContextChild bcc = BeanContextChildHelper.narrow(list[k]);
      String id = bcc.getObjectID();
      System.out.println("Next child:"+id);
    }


  }
 
}
 class comparator implements Comparator{

  public int compare(java.lang.Object o1, java.lang.Object o2)
    {
      String[] ol1 = (String[])o1;
      String[] ol2 = (String[])o2;

      String ID_1 = ol1[0];
      String ID_2 = ol2[0];
      return ID_1.compareTo(ID_2);
    }
  }


